

slowdown:
	rts

newline:
	clr.l d2			;new line
	addq.l #1,d5

	cmp.b #17,d5
	bcc lbl59233
	rts
lbl59233

cls:
	moveM.l d1/d4/d3/d6,-(sp)
		clr.l d2
		clr.l d5
;                                     		ld hl,&2000
		move.b #$20,d3
		
		clr.b d6
;                                     		ld bc,&2018
		move.b #$20,d1
		move.b #$18+1,d4
		jsr fillarea
	moveM.l (sp)+,d1/d4/d3/d6
	rts

fillarea:
	moveM.l d2/d5,-(sp)
fillareab:
		moveM.l d1/d4/d2/d5,-(sp)
fillareax:
			move.b d3,d0
			jsr printchar
			add.b d6,d3
	
			subq.b #1,d1
			bne fillareax
		moveM.l (sp)+,d1/d4/d2/d5
		addq.b #1,d5
		subq.b #1,d4
		bne fillareab
	moveM.l (sp)+,d2/d5
	rts

	

ReadJoystick:		;Returns: ---7654S321RLDU
	moveM.l d1-d4,-(sp)
		move.b #%00111111,$BFE201	;Direction for port A (BFE001)....0=in 1=out... 
									;(For fire buttons)

		;move.w $dff00A,d2			;Joystick-mouse 0 data (vert,horiz) (Joy2)
		;move.b $bfe001,d5			;/FIR1 /FIR0  /RDY /TK0  /WPRO /CHNG /LED  OVL
		;rol.b #1,d5					;Fire0 for joy 2
			
		move.w $dff00c,d2		;Joystick-mouse 1 data (vert,horiz) (Joy1)
		move.b $bfe001,d7		;/FIR1 /FIR0  /RDY /TK0  /WPRO /CHNG /LED  OVL

Player_ReadControlsOne:	;Translate HV data into joystick values
		clr.l d0	
		clr.l d1
		clr.l d3
		clr.l d4
		
		;Get the 4 bits that are needed for the directions
		roxr.l #1,d2	;bit 0
		roxl.l #1,d3
		roxr.l #1,d2	;bit 1
		roxl.l #1,d4
		roxr.l #7,d2	;bit 8
		roxl.l #1,d0
		and.l #1,d2		;bit 9
		
		;Calculate the new directions
		move.b d2,d1
		eor.b d0,d1
		roxr.b d1
		roxr.b d0		;Up (Bit 9 Xor 8)
		
		move.b d4,d1
		eor.b d3,d1
		roxr.b d1
		roxr.b d0		;Down (Bit 1 Xor 0)
		
		roxr.b d2
		roxr.b d0		;Left (Bit 9)
		roxr.b d4
		roxr.b d0		;Right (Bit 1)
		
		roxl.b d7
		roxr.b d0		;Fire
		
		ror.b #3,d0
		eor.b #%11101111,d0	;Invert UDLR bits
		or.l #$FFFFFF00,d0	;Set unused bits
	moveM.l (sp)+,d1-d4	
		
	rts
	
	
	
printnumber:
	add.b #48,d0		;ascii 0
printchar:				;print char a with sprite routine
	tst.b d0
	beq printchar0

	clr.l d7
	move.b d0,d7
	sub.b #32,d7			;Font doesn't have chars below 32
	cmp.b #64,d7
	bcs notlowercase
		sub.b #32,d7		;we don't define lowercase, convert to upper!
notlowercase:
	rol.l #3,d7				; 8 bytes per character
	move.l #FontData,a4
	add.l d7,a4
	
		move.l  #screen_mem,a0  ; Move address to screen mem to d0
						
		clr.l d7
		move.b d2,d7
		add.l d7,a0
		
		clr.l d7
		move.b d5,d7
		mulu #40*8*4,d7
		add.l d7,a0
		
		
		move.l #8-1,d7
nextline:
		move.b  (a4),(a0)
		move.b  (a4),(40*1,a0)
		move.b  (a4),(40*2,a0)
		move.b  (a4)+,(40*3,a0)
		
		add.l #40*4,a0
		dbra d7,nextline	
	
		
printchar0:
	addq.b #1,d2
	rts
	
waitVBlank:
	move.l ($DFF004),d0		;VPOSR - Read vert most signif. bit (and frame flop)
	and.l #$1ff00,d0
	cmp.l #$12C00,d0		;Test to see if we're in Vblank
	bne waitVBlank
VblankDone:		

	rts

	
FontData:												;Bitmap Font (4 color)
		dc.b 0,0,0,0,0,0,0,0
	        dc.b $10,$18,$18,$18,$18,$00,$18,$00     ;  0
        dc.b $28,$6C,$28,$00,$00,$00,$00,$00     ;  1
        dc.b $00,$28,$7C,$28,$7C,$28,$00,$00     ;  2
        dc.b $18,$3E,$48,$3C,$12,$7C,$18,$00     ;  3
        dc.b $02,$C4,$C8,$10,$20,$46,$86,$00     ;  4
        dc.b $10,$28,$28,$72,$94,$8C,$72,$00     ;  5
        dc.b $0C,$1C,$30,$00,$00,$00,$00,$00     ;  6
        dc.b $18,$18,$30,$30,$30,$18,$18,$00     ;  7
        dc.b $18,$18,$0C,$0C,$0C,$18,$18,$00     ;  8
        dc.b $08,$49,$2A,$1C,$14,$22,$41,$00     ;  9
        dc.b $00,$18,$18,$7E,$18,$18,$00,$00     ; 10
        dc.b $00,$00,$00,$00,$00,$18,$18,$30     ; 11
        dc.b $00,$00,$00,$7E,$7E,$00,$00,$00     ; 12
        dc.b $00,$00,$00,$00,$00,$18,$18,$00     ; 13
        dc.b $02,$04,$08,$10,$20,$40,$80,$00     ; 14
        dc.b $7C,$C6,$D6,$D6,$D6,$C6,$7C,$00     ; 15
        dc.b $10,$18,$18,$18,$18,$18,$08,$00     ; 16
        dc.b $3C,$7E,$06,$3C,$60,$7E,$3C,$00     ; 17
        dc.b $3C,$7E,$06,$1C,$06,$7E,$3C,$00     ; 18
        dc.b $18,$3C,$64,$CC,$7C,$0C,$08,$00     ; 19
        dc.b $3C,$7E,$60,$7C,$06,$7E,$3E,$00     ; 20
        dc.b $3C,$7E,$60,$7C,$66,$66,$3C,$00     ; 21
        dc.b $3C,$7E,$06,$0C,$18,$18,$10,$00     ; 22
        dc.b $3C,$66,$66,$3C,$66,$66,$3C,$00     ; 23
        dc.b $3C,$66,$66,$3E,$06,$7E,$3C,$00     ; 24
        dc.b $00,$00,$18,$18,$00,$18,$18,$00     ; 25
        dc.b $00,$00,$18,$18,$00,$18,$18,$30     ; 26
        dc.b $0C,$1C,$38,$60,$38,$1C,$0C,$00     ; 27
        dc.b $00,$00,$7E,$00,$00,$7E,$00,$00     ; 28
        dc.b $60,$70,$38,$0C,$38,$70,$60,$00     ; 29
        dc.b $3C,$76,$06,$1C,$00,$18,$18,$00     ; 30
        dc.b $7C,$CE,$A6,$B6,$C6,$F0,$7C,$00     ; 31
        dc.b $18,$3C,$66,$66,$7E,$66,$24,$00     ; 32
        dc.b $3C,$66,$66,$7C,$66,$66,$3C,$00     ; 33
        dc.b $38,$7C,$C0,$C0,$C0,$7C,$38,$00     ; 34
        dc.b $3C,$64,$66,$66,$66,$64,$38,$00     ; 35
        dc.b $3C,$7E,$60,$78,$60,$7E,$3C,$00     ; 36
        dc.b $38,$7C,$60,$78,$60,$60,$20,$00     ; 37
        dc.b $3C,$66,$C0,$C0,$CC,$66,$3C,$00     ; 38
        dc.b $24,$66,$66,$7E,$66,$66,$24,$00     ; 39
        dc.b $10,$18,$18,$18,$18,$18,$08,$00     ; 40
        dc.b $08,$0C,$0C,$0C,$4C,$FC,$78,$00     ; 41
        dc.b $24,$66,$6C,$78,$6C,$66,$24,$00     ; 42
        dc.b $20,$60,$60,$60,$60,$7E,$3E,$00     ; 43
        dc.b $44,$EE,$FE,$D6,$D6,$D6,$44,$00     ; 44
        dc.b $44,$E6,$F6,$DE,$CE,$C6,$44,$00     ; 45
        dc.b $38,$6C,$C6,$C6,$C6,$6C,$38,$00     ; 46
        dc.b $38,$6C,$64,$7C,$60,$60,$20,$00     ; 47
        dc.b $38,$6C,$C6,$C6,$CA,$74,$3A,$00     ; 48
        dc.b $3C,$66,$66,$7C,$6C,$66,$26,$00     ; 49
        dc.b $3C,$7E,$60,$3C,$06,$7E,$3C,$00     ; 50
        dc.b $3C,$7E,$18,$18,$18,$18,$08,$00     ; 51
        dc.b $24,$66,$66,$66,$66,$66,$3C,$00     ; 52
        dc.b $24,$66,$66,$66,$66,$3C,$18,$00     ; 53
        dc.b $44,$C6,$D6,$D6,$FE,$EE,$44,$00     ; 54
        dc.b $C6,$6C,$38,$38,$6C,$C6,$44,$00     ; 55
        dc.b $24,$66,$66,$3C,$18,$18,$08,$00     ; 56
        dc.b $7C,$FC,$0C,$18,$30,$7E,$7C,$00     ; 57
        dc.b $1C,$30,$30,$30,$30,$30,$1C,$00     ; 58
        dc.b $80,$40,$20,$10,$08,$04,$02,$00     ; 59
        dc.b $38,$0C,$0C,$0C,$0C,$0C,$38,$00     ; 60
        dc.b $18,$3C,$7E,$18,$18,$18,$18,$00     ; 61
        dc.b $00,$00,$00,$00,$00,$00,$FF,$FF     ; 62
        dc.b $30,$18,$0C,$00,$00,$00,$00,$00     ; 63
        dc.b $00,$00,$38,$0C,$7C,$CC,$78,$00     ; 64
        dc.b $20,$60,$7C,$66,$66,$66,$3C,$00     ; 65
        dc.b $00,$00,$3C,$66,$60,$66,$3C,$00     ; 66
        dc.b $08,$0C,$7C,$CC,$CC,$CC,$78,$00     ; 67
        dc.b $00,$00,$3C,$66,$7E,$60,$3C,$00     ; 68
        dc.b $1C,$36,$30,$38,$30,$30,$10,$00     ; 69
        dc.b $00,$00,$3C,$66,$66,$3E,$06,$3C     ; 70
        dc.b $20,$60,$6C,$76,$66,$66,$24,$00     ; 71
        dc.b $18,$00,$18,$18,$18,$18,$08,$00     ; 72
        dc.b $06,$00,$04,$06,$06,$26,$66,$3C     ; 73
        dc.b $20,$60,$66,$6C,$78,$6C,$26,$00     ; 74
        dc.b $10,$18,$18,$18,$18,$18,$08,$00     ; 75
        dc.b $00,$00,$6C,$FE,$D6,$D6,$C6,$00     ; 76
        dc.b $00,$00,$3C,$66,$66,$66,$24,$00     ; 77
        dc.b $00,$00,$3C,$66,$66,$66,$3C,$00     ; 78
        dc.b $00,$00,$3C,$66,$66,$7C,$60,$20     ; 79
        dc.b $00,$00,$78,$CC,$CC,$7C,$0C,$08     ; 80
        dc.b $00,$00,$38,$7C,$60,$60,$20,$00     ; 81
        dc.b $00,$00,$3C,$60,$3C,$06,$7C,$00     ; 82
        dc.b $10,$30,$3C,$30,$30,$3E,$1C,$00     ; 83
        dc.b $00,$00,$24,$66,$66,$66,$3C,$00     ; 84
        dc.b $00,$00,$24,$66,$66,$3C,$18,$00     ; 85
        dc.b $00,$00,$44,$D6,$D6,$FE,$6C,$00     ; 86
        dc.b $00,$00,$C6,$6C,$38,$6C,$C6,$00     ; 87
        dc.b $00,$00,$24,$66,$66,$3E,$06,$7C     ; 88
        dc.b $00,$00,$7E,$0C,$18,$30,$7E,$00     ; 89
        dc.b $08,$08,$08,$08,$56,$55,$57,$74     ; 90
        dc.b $18,$04,$08,$1C,$56,$55,$57,$74     ; 91
        dc.b $00,$00,$00,$00,$7E,$7E,$FF,$FF     ; 92
        dc.b $18,$3C,$18,$18,$18,$18,$7E,$FF     ; 93
        dc.b $22,$77,$7F,$7F,$3E,$1C,$08,$00     ; 94
        dc.b $3C,$7E,$ED,$FF,$7F,$2A,$54,$3C     ; 95
	

	CNOP 0,4	; Pad with NOP to next 32 bit boundary
gfxname dc.b 'graphics.library',0

	CNOP 0,4	; Pad with NOP to next 32 bit boundary
gfxbase:	dc.l 0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	Section ChipRAM,Data_c		;Request memory within the 'Chip Ram' base memory 
								;This is the only ram our screen and copperlist can use
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	CNOP 0,4					;Pad with NOP to next 32 bit boundary
	
Screen_Mem:						;This is our screen
	ds.b    320*200*4			;320x200 4 bitplanes (16 color)

	CNOP 0,4					;Pad with NOP to next 32 bit boundary
CopperList:
	dc.l $ffffffe 				;COPPER_HALT - end of list (new list)
	ds.b 1024					;Define 1024 bytes of chip ram for our copperlist

ramarea:
	ds.b 256


		