screenwidth equ ramarea+2

ChibiSound:
ChibiSoundBeep:
	rts
	
DoLdir:	
	move.b (a3)+,(a2)+
	subq.w #1,d1
	bne DoLdir
	rts

DoLddr:	
	move.b (a3),(a2)
	subq.w #1,a3
	subq.w #1,a2
	subq.w #1,d1
	bne DoLddr
	rts	

ClearRam:	
	move.l #ramarea,a0
	move.l #256-1,d0
ClearRamB:	
	clr.b (a0)+
	dbra d0,ClearRamB
	
	clr.l d0
	clr.l d1
	clr.l d2
	clr.l d3
	clr.l d4
	clr.l d5
	clr.l d6
	jmp cls


	
printseqnc:
	move.l d4,d5	;restore ypos
	addq.l #1,d2	;inc xpos
	bra printseq

printseqnl:
	move.l d1,d2		;restore xpos
	addq.l #1,d5		;inc ypos
printseq:				;print seq hl at location de
	move.l d2,d1
	move.l d5,d4

;&00     = empty (nothing drawn)
printseqb:
	move.b (a3)+,d0		;get a char
	beq doprintchar						;0=empty char

	cmp.b #32,d0
	bcs xposchange			;&01-&1f = new absolute xpos (use nl for xpos=0)

	cmp.b #$e0,d0
	bcc yposchange			;&e0-&f8 = new absolute ypos

	cmp.b #$a0,d0
	bcc sequenceh			;&a0-&bf = horizontal sequence of one char
doprintchar:
	jsr printchar			;&20-&9f = character
	bra printseqb

sequenceh:
	moveM.l d1/d4,-(sp)
		cmp.b #$c0,d0
		bcc sequencev		;&c0-&df = vertical sequence of one char
		and.l #$1f,d0
		addq.l #1,d0
		move.b d0,d1
		
		move.b (a3)+,d0			;get a char

sequenceh2:
		jsr printchar
		subq.b #1,d1
		bne sequenceh2

printseq_poprep:
	moveM.l (sp)+,d1/d4
	bra printseqb

sequencev:
	and.l #$1f,d0
	addq.l #1,d0
	move.l d0,d1
	move.b (a3)+,d0	;get a char

sequencev2:
	moveM.l d2/d5,-(sp)
		;move.l #'x',d0
		jsr printchar
	moveM.l (sp)+,d2/d5
	addq.l #1,d5
	subq.b #1,d1
	bne sequencev2
	bra printseq_poprep

xposchange:
	move.b d0,d2
	bra printseq

yposchange:
	cmp.b #251,d0
	beq printseqfill	;&fb	 = fill area (w,h,char,inc)

	cmp.b #252,d0				
	beq printseqnc		;&fc 	 = new column (vertical)

	cmp.b #253,d0
	beq printseqcrnl	;&fd     = new line (true)

	cmp.b #254,d0
	beq printseqnl		;&fe     = new line (horizontal)

	cmp.b #255,d0		;&ff     = end of list
	bne lbl22306		;yes? then return
	rts
lbl22306
	move.l d1,d2
	and.b #$1f,d0
	move.b d0,d5		;new ypos
	bra printseqb

printseqfill:
	moveM.l d1/d4,-(sp)
		move.b (a3)+,d1		;w
	
		move.b (a3)+,d4		;h

		move.b (a3)+,d0		;char
		moveM.l d3/d6,-(sp)
			move.b (a3),d6
			move.b d0,d3
			jsr fillarea
		moveM.l (sp)+,d3/d6
		addq.l #1,a3
	bra printseq_poprep

printseqcrnl:
	;addq.l #1,(a3)
	;rts
	jsr newline		;zero x, move down a line
	bra printseq

waitforfire:
	jsr waitforrelease
waitforfire2:
	jsr dorandom
	jsr readjoystick

	btst #4,d0
	bne waitforfire2
	rts

waitforrelease:
	jsr readjoystick
	cmp.b #255,d0
	bne waitforrelease
	rts

pause50:
	move.l #50,d0

pausea:
	and.l #$FF,d0
pausea2:
	move.l #1000,d7
pausea3:
	subq.w #1,d7
	bne pausea3
	
	subq.b #1,d0
	bne pausea2
	rts

showdecimal:	;draw a 3 digit decimal number (non-bcd)
	moveM.l d0/d1/d3,-(sp)
		move.l #100,d3
		jsr divideabyh	;/100

		move.l #10,d3
		move.b d1,d0
		jsr divideabyh		;/10

		move.b d1,d0
		jsr printnumber	;/1
	moveM.l (sp)+,d0/d1/d3
	rts

divideabyh:
	and.l #$ff,d3
	and.l #$ff,d0

	divu d3,d0			;D0=D0/3 (remainder in top word)

	move.l d0,d1		;remainder
	lsr.l #8,d1
	lsr.l #8,d1
	jmp printnumber


joyaxis:		;a=val c=joypresses
	move.b d0,d1
	btst #0,d4	;up or left
	bne notupleft

	subq.l #1,d0

notupleft:
	btst #1,d4		;down or right
	bne notdownright

	addq.l #1,d0
notdownright:
	lsr #2,d4	;skip 2 direction bits
	rts

;return a value between d and e
rangedrandom:
	jsr dorandom
	jsr rangetest
	bcs lbl59467
	rts
lbl59467
	bra rangedrandom

rangelimit:				;reset a=b if over range de
	jsr rangetest
	bcs lbl60376
	rts
lbl60376
	move.l d1,d0
	rts

;ensure a is between d and e
rangetest:
	cmp.b d5,d0
	bcc setcarry	;higher or equal to e
	cmp.b d2,d0		;c=lower than d
	rts

setcarry:
	ori #%00000001,CCR
	rts

randomseed equ ramarea	;2 bytes

dorandom:
	movem.l d1/d4,-(sp)
		move.w (randomseed),d0
		addq.l #1,d0
		move.w d0,(randomseed)
		
		move.b (randomseed),d1
		move.b (randomseed+1),d4
		
		eor.b d4,d0
		ror.b #1,d0
		eor.b d3,d0
		ror.b #1,d0
		eor.b d2,d0
		eor.b d1,d0		;xor 1st seend
		ror.b #1,d0
		eor.b d6,d0
		ror.b #1,d0
		eor.b d5,d0
		eor.b d4,d0
		ror.b #1,d0
		eor.b #%10011101,d0
		eor.b d4,d0
	movem.l (sp)+,d1/d4
	rts

