;Define a Little Endian 16 bit word
; if a 32 bit long is provided it is truncated

	; macro dwle
		; dc.b \1&255
		; dc.b (\1/256)&255
	; endm

; Spr_XY equ 0
; Spr_WH equ 2
; Spr_TilemapHL equ 4
; Spr_PatternHL equ 6
; Spr_CropCache equ 8
; Spr_CropCache_Back equ 18



RunTest1:
	move.l #backgroundtilemap2+2,d3	;Default background tilemap
	move.l d3,(backgroundtilemapbase)

	move.l #36*2,d3
	move.b d3,(backgroundtilemapwidth)
	jsr setscroll
	
;Define the cropping area to use the full window
	
	move.b #vscreenminy,d0
	move.b d0,(cropyh+1)

	move.b #vscreenhei-vscreenheiclip,d0
	move.b d0,(cropyh)

	move.b #vscreenminx,d0
	move.b d0,(cropxw+1)
	
	move.b #vscreenwid-vscreenwidclip,d0
	move.b d0,(cropxw)
			
	jsr DrawScreen				;Draw the screen

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	

InfLoop:
	move.l #backgroundtilemapbase,a3	;Scroll the background a unit

	clr.l d0
	move.b (backgroundtilemapscrollx),d0
	addq.b #2,d0
	ifnd allowhalftilescroll
		addq.b #2,d0
	endif
	move.b d0,(backgroundtilemapscrollx)

	move.b (backgroundtilemapscrolly),d0
	addq.b #2,d0

	ifnd allowhalftilescroll
		addq.b #2,d0
	endif

	move.b d0,(backgroundtilemapscrolly)
	ifd allowhalftilescroll
		jsr setscroll		;full scroll redraw
	else
		jsr resetscroll		;partial scroll redraw
	endif

	jsr drawscreen			;Flush caches to screen

	
;Delay loop
	ifd BuildNeo
		move.l #$10000,d0
slowdown1:
		subq.l #1,d0
		bne slowdown1
	endif
	
	jmp infloop

	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
drawscreen:
redrawcaches:
	ifnd doublebuffered
		move.l #cachetable,a5
		jmp fastdrawcaches		;Draw the caches in order
	endif
	rts
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RecalcScroll:		;Update Base according to scroll
	move.l #backgroundtilemap2,d3
	move.b (backgroundtilemapscrollx),d1
	and.l #%000001100,d1	;%????TTHH  T=whole Tile H=Half/Quarter
	lsr.l #1,d1				;2 bytes per tile
	add.l d1,d3

	clr.l d1
	move.b (backgroundtilemapwidth),d1
	move.b (backgroundtilemapscrolly),d0
	and.l #%00001100,d0		;%????tthh
	lsr.b #2,d0
	beq recalcscrolldone

	mulu d0,d1
	add.l d1,d3	
recalcscrolldone:

	move.l d3,(backgroundtilemapbase)		;Store new base
	move.l #backgroundtilemapwidthv*24,d1
	move.l d3,a3
	rts
	
	
	
setscroll:	;full scroll redraw

	jsr recalcscroll		;Recacluate Scroll pos
	
	ifnd doublebuffered
		jsr resettilemap	;Force tilemap redraw
	endif

resetscrollb:
	move.l #patterndata,a3
	move.l (backgroundtilemapbase),a2
	jmp cache_tilemapcls	;Draw the tilemap

	
	
	
	;D1/BC = Tile count
resetscroll:	;partial scroll redraw
	move.l (backgroundtilemapbase),a2
	jsr recalcscroll			
	jsr resettilemapshift	;Flag the tilemap for redraw
	bra resetscrollb		; where tile onscreen has changed

resettilemapshift:

	ifnd doublebuffered
		move.b (a2),d0		;Tilemap Src
		and.l #%11111110,d0	;Ignore update flag
		cmp.b (a3),d0		;Tilemap Dest
		bne resettilemapchange		;Changed?
				
		move.b (1,a2),d0
		cmp.b (1,a3),d0
		beq resettilemapshiftskip	;Changed?
resettilemapchange:
		bset.b #0,(a3)				;Yes -Flag update
resettilemapshiftskip:
		addq.l #2,a3
		addq.l #2,a2

		subq.l #1,d1				;Tile Count
		bne resettilemapshift
	endif
	rts
	
	
	
	ifnd doublebuffered
fastdrawcaches:						;A5/IY= Cachelist
		move.b #cacheentries,d1		;No of caches
redrawcacheagain:
		move.l d1,-(sp)
			move.l a5,-(sp)
				jsr getcacheiy		;Get Cache A4 from list A5
				beq lbl17424
					jsr processcache	;NZ=Data to process
lbl17424
			move.l (sp)+,a5
			add.l #cacheentrybytes,a5	;Move to next cache
		move.l (sp)+,d1
		subq.b #1,d1				
		bne redrawcacheagain

		jmp resetcaches
	endif

	
	

;%NNCCXYPU	U=update P=Program YX=flip CC=color/more NN NN=Tile H

;BB = Bank / palette / top 2 bits of tile num

;$???0 %???????0 ???????? = Tile to be skipped
;$???1 %???????1 ???????? = Tile to be drawn
;$nnn1 %nnnnBB01 nnnnnnnn = Normal tile       ($-1)
;$nnP3 %BBPP0011 nnnnnnnn = Custom Program PP ($-3) (PP=0... Fill / PP=1... Stretch / pp=3+bb=3... empty (for sprites / pp=2 unused)
;$nn03 %BBPP0011 nnnnnnnn = Program Fill
;$nn13 %BBPP0011 nnnnnnnn = Program Stretch
;$FFF3 %11110011 11111111 = Program Empty tile	($F3 FF  /  F2 FF)
;$nn33 %nn110011 nnnnnnnn = Transparent tile	($33 nn  / $7C nn  /  BC nn  /  F3nn)
;$nnn7 %nnnn0111 BBnnnnnn = Y flipped tile    ($-7)
;$nnnB %nnnn1011 BBnnnnnn = X flipped tile    ($-B)
;$nnnF %nnnn1111 nnnnnnnn = XY flipped tile   ($-F)


T_BackgroundTilemap2:			;NEED TO Swap ENDIAN!

	dc.w $0031,$0041,$0051,$0061,$0071,$0081,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080
	dc.w $0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080
	dc.w $0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080
	dc.w $0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080

	;Filled
	dc.w $0003,$0103,$0203,$0303,$0403,$0503,$0603,$0703,$0803,$0903,$0A03,$0B03,$0C03,$0D03,$0E03,$0F03,$1003,$1103,$1203,$1303,$1403,$1503,$1603,$1703,$1803,$1903,$1A03,$1B03,$1C03,$1D03,$1E03,$1F03,$0050,$0050,$0050,$0050
	dc.w $0003,$0103,$0203,$0303,$0403,$0503,$0603,$0703,$0803,$0903,$0A03,$0B03,$0C03,$0D03,$0E03,$0F03,$1003,$1103,$1203,$1303,$1403,$1503,$1603,$1703,$1803,$1903,$1A03,$1B03,$1C03,$1D03,$1E03,$1F03,$0050,$0050,$0050,$0050
	dc.w $0003,$0103,$0203,$0303,$0403,$0503,$0603,$0703,$0803,$0903,$0A03,$0B03,$0C03,$0D03,$0E03,$0F03,$1003,$1103,$1203,$1303,$1403,$1503,$1603,$1703,$1803,$1903,$1A03,$1B03,$1C03,$1D03,$1E03,$1F03,$0050,$0050,$0050,$0050
	dc.w $0003,$0103,$0203,$0303,$0403,$0503,$0603,$0703,$0803,$0903,$0A03,$0B03,$0C03,$0D03,$0E03,$0F03,$1003,$1103,$1203,$1303,$1403,$1503,$1603,$1703,$1803,$1903,$1A03,$1B03,$1C03,$1D03,$1E03,$1F03,$0050,$0050,$0050,$0050

	dc.w $0030,$0040,$0050,$0060,$0070,$0080,$0090,$00A0,$00B0,$00C0,$00D0,$00E0,$00F0,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080
	;Yflip
	dc.w $0037,$0047,$0057,$0067,$0077,$0087,$0097,$00A7,$00B7,$00C7,$00D7,$00E7,$00F7,$0037,$0037,$0037,$0037,$0037,$0037,$0037,$0037,$0037,$0037,$0037,$0037,$0037,$0037,$0037,$0037,$0037,$0037,$0037,$0037,$0037,$0037,$0037
	;Xflip
	dc.w $003B,$004B,$005B,$006B,$007B,$008B,$009B,$00AB,$00BB,$00CB,$00DB,$00EB,$00FB,$003B,$003B,$003B,$003B,$003B,$003B,$003B,$003B,$003B,$003B,$003B,$003B,$003B,$003B,$003B,$003B,$003B,$003B,$003B,$003B,$003B,$003B,$003B
	;XYflip
	dc.w $003F,$004F,$005F,$006F,$007F,$008F,$009F,$00AF,$00BF,$00CF,$00DF,$00EF,$00FF,$003F,$003F,$003F,$003F,$003F,$003F,$003F,$003F,$003F,$003F,$003F,$003F,$003F,$003F,$003F,$003F,$003F,$003F,$003F,$003F,$003F,$003F,$003F

	;More Flips
	dc.w $0030,$0030,$0030,$0030,$0037,$0037,$0037,$0037,$003B,$003B,$003B,$003B,$003F,$003F,$003F,$003F,$0040,$0040,$0040,$0040,$0047,$0047,$0047,$0047,$004B,$004B,$004B,$004B,$004F,$004F,$004F,$004F,$0030,$0030,$0030,$0030

	;Double
	dc.w $1213,$2213,$3213,$0813,$1013,$1213,$1413,$0613,$0413,$003B,$003B,$003B,$003F,$003F,$003F,$003F,$0030,$0030,$0030,$0030,$0037,$0037,$0037,$0037,$003B,$003B,$003B,$003B,$003F,$003F,$003F,$003F,$0030,$0030,$0030,$0030
	dc.w $1313,$2313,$3313,$0913,$1113,$1313,$1513,$0713,$0513,$003B,$003B,$003B,$003F,$003F,$003F,$003F,$0030,$0030,$0030,$0030,$0037,$0037,$0037,$0037,$003B,$003B,$003B,$003B,$003F,$003F,$003F,$003F,$0030,$0030,$0030,$0030
		
	dc.w $0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030
	dc.w $0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030
	dc.w $0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030
	dc.w $0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030

	dc.w $0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080
	dc.w $0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080
	dc.w $0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080
	dc.w $0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080

	dc.w $0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030
	dc.w $0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030
	dc.w $0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030
	dc.w $0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030

	dc.w $0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080
	dc.w $0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080
	dc.w $0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080
	dc.w $0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080

	dc.w $0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030
	dc.w $0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030
	dc.w $0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030
	dc.w $0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030,$0030

	dc.w $0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080
	dc.w $0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080
	dc.w $0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080
	dc.w $0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080,$0030,$0040,$0050,$0060,$0070,$0080

	dc.w 0,0,0,0	
