
;A0 A1 A2 A3
;D0 D1 D2

;A4=IX
;A2=Tilemap A1=TileOffset A3=Vram dest
			
drawtile:
	ifd drawtileShifted			;For part tile X-shift
		move.l a3,d2
		and.l #$C0000000,d2		;Need xshift?
		bne drawtileShifted
	endif
	
	btst #0,d0			;%-NNBBXYP U

	ifnd tiletest_basiconly		;for minimal testing
		bne drawtileadvanced
	endif
	
	asl.b #1,d0			;%NNBBXYP0 ... Update flag cleared (bit 0)
	move.b d0,(a2)+

drawtilebasiconly:
	and.b #%11110000,d0	;nnnn----

	clr.l D2
	move.b d0,D2
	
	clr.l d0
	move.b (a2)+,d0		;%NNNNNNNN
	
	asl.l #8,d0
	or.w d0,D2			;NNNNNNNN nnnn----
	
	lsl.l #1,d2			;32 bytes per tile
	
	add.l a1,D2			;Add Tile Base
	move.l d2,a0		;Tile Pattern source in A0

	
	move.b (a0)+,(a3)		;Bitplane 0
	move.b (a0)+,(40,a3)	;Bitplane 1
	move.b (a0)+,(80,a3)	;Bitplane 2
	move.b (a0)+,(120,a3)	;Bitplane 3
	
	move.b (a0)+,(160*1+0,a3)	;Bitplane 0
	move.b (a0)+,(160*1+40,a3)	;Bitplane 1
	move.b (a0)+,(160*1+80,a3)	;Bitplane 2
	move.b (a0)+,(160*1+120,a3)	;Bitplane 3
	
	move.b (a0)+,(160*2+0,a3)	;Bitplane 0
	move.b (a0)+,(160*2+40,a3)	;Bitplane 1
	move.b (a0)+,(160*2+80,a3)	;Bitplane 2
	move.b (a0)+,(160*2+120,a3)	;Bitplane 3
	
	move.b (a0)+,(160*3+0,a3)	;Bitplane 0
	move.b (a0)+,(160*3+40,a3)	;Bitplane 1
	move.b (a0)+,(160*3+80,a3)	;Bitplane 2
	move.b (a0)+,(160*3+120,a3)	;Bitplane 3
	
	move.b (a0)+,(160*4+0,a3)	;Bitplane 0
	move.b (a0)+,(160*4+40,a3)	;Bitplane 1
	move.b (a0)+,(160*4+80,a3)	;Bitplane 2
	move.b (a0)+,(160*4+120,a3)	;Bitplane 3
	
	move.b (a0)+,(160*5+0,a3)	;Bitplane 0
	move.b (a0)+,(160*5+40,a3)	;Bitplane 1
	move.b (a0)+,(160*5+80,a3)	;Bitplane 2
	move.b (a0)+,(160*5+120,a3)	;Bitplane 3
	
	move.b (a0)+,(160*6+0,a3)	;Bitplane 0
	move.b (a0)+,(160*6+40,a3)	;Bitplane 1
	move.b (a0)+,(160*6+80,a3)	;Bitplane 2
	move.b (a0)+,(160*6+120,a3)	;Bitplane 3
	
	move.b (a0)+,(160*7+0,a3)	;Bitplane 0
	move.b (a0)+,(160*7+40,a3)	;Bitplane 1
	move.b (a0)+,(160*7+80,a3)	;Bitplane 2
	move.b (a0)+,(160*7+120,a3)	;Bitplane 3
	
	jmp tiledone


drawtileadvanced:
	and.b #%00000110,d0			;%-NNBBXYP
	beq drawtilecustom			;X,Y flip 0 = special prog
	
	move.b (a2),d0
	and.b #%11111110,d0			;Clear Update Flag
	move.b d0,(a2)+

	ifd tiletest_noflip	;for minimal testing
		bra drawtilebasiconly
	endif

	clr.l D2
	and.b #%11110000,d0			;nnnn---
	move.b d0,D2
	
	clr.l d0
	move.b (a2),d0				;%NNNNNNNN
	subq.l #1,a2	
	
	asl.l #8,d0
	or.w d0,D2					;NNNNNNNN nnnn----
	
	asl.l #1,d2
	add.l a1,D2					;Add Tile Base
	move.l d2,a0
	
	move.l a3,d2				;Backup VRAM pos
		
	move.b (a2),d0
	addq.l #2,a2

	
	btst #2,d0
	bne drawtileyflip

drawtilexflip:
	move.l a1,-(sp)
		move.l #FlipLUT,a1	;Xflip Lookup Table
		move.l #160,d3
		move.w #7,d1		;Line Count -1
		clr.l d0
		
DrawTileNextLineRev:	
		move.b (a0)+,d0		;Get a source byte
		move.b (a1,d0),d0	;Convert via LUT
		move.b d0,(a3)		;Bitplane 0
		
		move.b (a0)+,d0		;Get a source byte
		move.b (a1,d0),d0	;Convert via LUT
		move.b d0,(40,a3)	;Bitplane 1
			
		move.b (a0)+,d0		;Get a source byte
		move.b (a1,d0),d0	;Convert via LUT
		move.b d0,(80,a3)	;Bitplane 2
		
		move.b (a0)+,d0		;Get a source byte
		move.b (a1,d0),d0	;Convert via LUT
		move.b d0,(120,a3)	;Bitplane 3

		add.l d3,a3		;Down one pixel line
		
		dbra d1,DrawTileNextLineRev

	move.l (sp)+,a1
	move.l d2,a3			;Restore VRAM pos
	jmp tiledone

	
drawtilexyflip:
	move.l a1,-(sp)
		move.l #FlipLUT,a1	;For Xflip

		move.l #160,d3		;For Down lone line
		
		add.l #4*8,a0		;Move to last pattern byte
		move.w #7,d1		;Line Count -1
		clr.l d0
				
DrawTileNextLineRevY:	
		move.b -(a0),d0		;Read 1 byte backward
		move.b (a1,d0),d0	;Xflip source byte
		move.b d0,(120,a3)	;Bitplane 0
				
		move.b -(a0),d0		;Read 1 byte backward
		move.b (a1,d0),d0	;Xflip source byte
		move.b d0,(80,a3)	;Bitplane 1
		
		move.b -(a0),d0		;Read 1 byte backward
		move.b (a1,d0),d0	;Xflip source byte
		move.b d0,(40,a3)	;Bitplane 2
		
		move.b -(a0),d0		;Read 1 byte backward
		move.b (a1,d0),d0	;Xflip source byte
		move.b d0,(a3)		;Bitplane 3
		
		add.l d3,a3
		dbra d1,DrawTileNextLineRevY		;Next line

	move.l (sp)+,a1
	move.l d2,a3			;Restore VRAM pos
	jmp tiledone

	
drawtileyflip:
	btst #3,d0
	bne drawtilexyflip
	
	move.b (a0)+,(160*7+0,a3)	;Bitplane 0
	move.b (a0)+,(160*7+40,a3)	;Bitplane 1
	move.b (a0)+,(160*7+80,a3)	;Bitplane 2
	move.b (a0)+,(160*7+120,a3)	;Bitplane 3
	
	move.b (a0)+,(160*6+0,a3)	;Bitplane 0
	move.b (a0)+,(160*6+40,a3)	;Bitplane 1
	move.b (a0)+,(160*6+80,a3)	;Bitplane 2
	move.b (a0)+,(160*6+120,a3)	;Bitplane 3
	
	move.b (a0)+,(160*5+0,a3)	;Bitplane 0
	move.b (a0)+,(160*5+40,a3)	;Bitplane 1
	move.b (a0)+,(160*5+80,a3)	;Bitplane 2
	move.b (a0)+,(160*5+120,a3)	;Bitplane 3
	
	move.b (a0)+,(160*4+0,a3)	;Bitplane 0
	move.b (a0)+,(160*4+40,a3)	;Bitplane 1
	move.b (a0)+,(160*4+80,a3)	;Bitplane 2
	move.b (a0)+,(160*4+120,a3)	;Bitplane 3
	
	move.b (a0)+,(160*3+0,a3)	;Bitplane 0
	move.b (a0)+,(160*3+40,a3)	;Bitplane 1
	move.b (a0)+,(160*3+80,a3)	;Bitplane 2
	move.b (a0)+,(160*3+120,a3)	;Bitplane 3
	
	move.b (a0)+,(160*2+0,a3)	;Bitplane 0
	move.b (a0)+,(160*2+40,a3)	;Bitplane 1
	move.b (a0)+,(160*2+80,a3)	;Bitplane 2
	move.b (a0)+,(160*2+120,a3)	;Bitplane 3
	
	move.b (a0)+,(160*1+0,a3)	;Bitplane 0
	move.b (a0)+,(160*1+40,a3)	;Bitplane 1
	move.b (a0)+,(160*1+80,a3)	;Bitplane 2
	move.b (a0)+,(160*1+120,a3)	;Bitplane 3
	
	move.b (a0)+,(a3)		;Bitplane 0
	move.b (a0)+,(40,a3)	;Bitplane 1
	move.b (a0)+,(80,a3)	;Bitplane 2
	move.b (a0)+,(120,a3)	;Bitplane 3
	
	jmp tiledone

	
drawtileempty:
	addq.l #1,a2
	move.b (a2)+,d0	;255=empty <255=tilenum
	
	cmp.b #255,d0
	bne drawtiletransp
	jmp tiledone
	
;;;;;;;;;;;;;;;;;;transparent

drawtiletransp:
	move.b d0,d2
	
	lsl.l #5,d2			;32 bytes per tile
	
	add.l a1,D2			;Add Tile Base
	move.l d2,a0
	
	move.l a3,d2		;Backup VRAM pos
	
		move.w #7,d1		;Line Count -1
		clr.l d0
	
		move.l #160,d3		;Width of line in bytes
		
DrawTileNextLineT:			;A3=Vram Dest
	
		move.b (a0),d0		;Build the mask
		or.b (1,a0),d0
		or.b (2,a0),d0
		or.b (3,a0),d0
		not.b d0			;Bit 1=keep background
							;Bit 0=Remove background (tile)
	
		and.b d0,(a3)		;Apply mask to bitplanes
		and.b d0,(40,a3)
		and.b d0,(80,a3)
		and.b d0,(120,a3)
	
	
		move.b (a0)+,d0
		or.b d0,(a3)		;Bitplane 0
		move.b (a0)+,d0
		or.b d0,(40,a3)		;Bitplane 1
		move.b (a0)+,d0
		or.b d0,(80,a3)		;Bitplane 2
		move.b (a0)+,d0
		or.b d0,(120,a3)	;Bitplane 3
	
		add.l d3,a3			;Down a VRAM line
		
		dbra d1,DrawTileNextLineT	;Next line
		
	move.l d2,a3			;Restore VRAM pos
	jmp tiledone


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

drawtilecustom:
	move.b (a2),d0			;%NNcc----
	and.b #%11111110,d0
	move.b d0,(a2)

	lsl.l #2,d0				;%NN --------
	and.l #%0000001100000000,d0
	move.l d0,D2

	move.b (a2),d0
	and.b #%11111110,d0
	move.b d0,(a2)
	and.b #%00110000,d0		;cmd bits
	bne notdrawtilefill
		jmp drawtilefill
notdrawtilefill:

	cmp.b #%00110000,d0
	beq drawtileempty
	

drawtiledouble:
	addq.l #1,a2
	move.b (a2)+,D2			;------NN nnnnnnnn - tile number
	
	asl.l #4,d2
	
	add.l a1,D2			;Add Tile Base
	move.l d2,a0		
	
	move.l a3,d2		;Backup VRAM pos
	
		move.l #160*2,d3
		move.w #3,d1		;Line Count -1
		
DrawTileNextLineD:			;A3=Vram Dest
		move.b (a0),(a3)			;Bitplane 0
		move.b (a0)+,(160,a3)		;Bitplane 0 - line 2
		move.b (a0),(40,a3)			;Bitplane 1
		move.b (a0)+,(160+40,a3)	;Bitplane 1 - line 2
		move.b (a0),(80,a3)			;Bitplane 2
		move.b (a0)+,(160+80,a3)	;Bitplane 2 - line 2
		move.b (a0),(120,a3)		;Bitplane 3
		move.b (a0)+,(160+120,a3)	;Bitplane 3 - line 2
		
		add.l d3,a3					;Down 2 VRAM lines
		
		dbra d1,DrawTileNextLineD	;Next line
	
	move.l d2,a3	;Restore VRAM pos
	jmp tiledone

	
drawtilefill:
	addq.l #1,a2
	move.b (a2),D2	;------NN nnnnnnnn - tile number
	addq.l #1,a2

	asl.b #2,d2				;Pattern *4
	add.l #patternFill,D2
	move.l d2,a0
		
	move.l d2,a0
		
DrawTileNextLineF:			;A3=Vram Dest
	move.b (a0)+,d0
	move.b d0,(a3)		;Bitplane 0
	move.b d0,(160*1,a3)
	move.b d0,(160*2,a3)
	move.b d0,(160*3,a3)
	move.b d0,(160*4,a3)
	move.b d0,(160*5,a3)
	move.b d0,(160*6,a3)
	move.b d0,(160*7,a3)
	
	move.b (a0)+,d0
	move.b d0,(40,a3)	;Bitplane 1
	move.b d0,(160*1+40,a3)
	move.b d0,(160*2+40,a3)
	move.b d0,(160*3+40,a3)
	move.b d0,(160*4+40,a3)
	move.b d0,(160*5+40,a3)
	move.b d0,(160*6+40,a3)
	move.b d0,(160*7+40,a3)
	
	move.b (a0)+,d0
	move.b d0,(80,a3)	;Bitplane 2
	move.b d0,(160*1+80,a3)
	move.b d0,(160*2+80,a3)
	move.b d0,(160*3+80,a3)
	move.b d0,(160*4+80,a3)
	move.b d0,(160*5+80,a3)
	move.b d0,(160*6+80,a3)
	move.b d0,(160*7+80,a3)
	
	move.b (a0)+,d0
	move.b d0,(120,a3)	;Bitplane 3
	move.b d0,(160*1+120,a3)
	move.b d0,(160*2+120,a3)
	move.b d0,(160*3+120,a3)
	move.b d0,(160*4+120,a3)
	move.b d0,(160*5+120,a3)
	move.b d0,(160*6+120,a3)
	move.b d0,(160*7+120,a3)
	
	jmp tiledone

	
;Addr= ScreenBase +4 + YposInLines*160 + XposInTiles
	
	ifnd drawtileShifted	;Use alternate shifted versions?
GetScreenPos:
		lea screen_mem+4,a3  	;Load address of screen (chip ram) 
								;+4 to center the screen.
		
		and.l #$FF,d1			;Clear all but the bottom byte
		move.l d1,d0			;Xpos
		lsr #2,d0				;Convert to tiles
		add.l d0,a3				;Add Xpos it bytes
		
		and.l #$FF,d4			;Ypos
		move.l d4,d0
		mulu #40*4*2,d0			;4 bitplanes 40 bytes per Y line 
		add.l d0,a3
		rts
	endif
	
	
	
	