
GetScreenPos:
	lea screen_mem+4,a3  	;Load address of screen (in chip ram) into A6
	
	and.l #$FF,d1			;Clear all but the bottom byte
	move.l d1,d0
	lsr #2,d0				;Convert to tiles
	add.l d0,a3				;Add X 
	
	clr.l d0
	move.b d1,d0
	and.l #%00000011,d0
	eor.b #%00000011,d0
	ror.l #2,d0				;Shift to top 2 bits
	add.l d0,a3				;Add X shift to Vram
	
	and.l #$FF,d4
	move.l d4,d0
	mulu #40*4*2,d0			;4 bitplanes 40 bytes per Y line 
	add.l d0,a3
	rts
	
	
	
;A0 A1 A2 A3
;D0 D1 D2

;A4=IX
;A2=Tilemap A1=TileOffset A3=Vram dest
			
drawtileShifted:	
	btst #0,d0
	ifnd tiletest_basiconly		;for minimal testing
		bne drawtileadvancedS
	endif
	
	asl.b #1,d0
	move.b d0,(a2)
	addq.l #1,a2

	
drawtilebasiconlyS:
	and.b #%11110000,d0		;%nnnn----

	clr.l D2
	move.b d0,D2
	
	clr.l d0
	move.b (a2),d0			;%NNNNNNNN
	addq.l #1,a2
	
	asl.l #8,d0
	or.w d0,D2				;NNNNNNNN nnnn----
	
	lsl.l #1,d2				;32 bytes per tile	
	add.l a1,D2				;Add Tile Base
	move.l d2,a0			;A0 = Tile Source
	
	jsr ShiftPrep			;Clear tile area and prep
	
	
drawtilebasiconlySL:	
		clr.l d0			;Bitplane 0
		move.b (a0)+,d0		;Load a source pattern byte
		lsl.l d4,d0			;Shift it
		or.l d0,(a3)		;OR it into VRAM
	
		clr.l d0			;Bitplane 1
		move.b (a0)+,d0		;Load a source pattern byte
		lsl.l d4,d0			;Shift it
		or.l d0,(40,a3)		;OR it into VRAM
		
		clr.l d0			;Bitplane 2
		move.b (a0)+,d0		;Load a source pattern byte
		lsl.l d4,d0			;Shift it
		or.l d0,(80,a3)		;OR it into VRAM
		
		clr.l d0			;Bitplane 3
		move.b (a0)+,d0		;Load a source pattern byte
		lsl.l d4,d0			;Shift it
		or.l d0,(120,a3)	;OR it into VRAM
		
		add.l d3,a3
		dbra d1,drawtilebasiconlySL

	move.l d2,a3	
	jmp tiledone

	
ShiftPrep:
	bclr #3,d4			;ensure bit 3 cleared in shift 
	
	move.l a3,d2		;Backup A3
	move.l d2,d0
	btst #0,d0			;Even byte vram Dest?
	bne NoBottomBit		;Were working in 16 bit pairs.
	bset #3,d4			;Yes, then we'll shift 8 bits left
NoBottomBit:	
	bclr #0,d0			;Move to word aligned pos
	move.l d0,a3
	
	subq.l #2,a3		;Compensate for the fact we read/write longs
		
	move.l #$FFFFFF00,d0	;Mask to remove the area for thsi tile
	rol.l d4,d0				;shift the mask left d4 bits
	
	and.l d0,(a3)			;Mask the background to make hole for tile
	and.l d0,(40,a3)
	and.l d0,(80,a3)
	and.l d0,(120,a3)
	
	and.l d0,(160*1,a3)
	and.l d0,(160*1+40,a3)
	and.l d0,(160*1+80,a3)
	and.l d0,(160*1+120,a3)
	
	and.l d0,(160*2,a3)
	and.l d0,(160*2+40,a3)
	and.l d0,(160*2+80,a3)
	and.l d0,(160*2+120,a3)
	
	and.l d0,(160*3,a3)
	and.l d0,(160*3+40,a3)
	and.l d0,(160*3+80,a3)
	and.l d0,(160*3+120,a3)
	
	and.l d0,(160*4,a3)
	and.l d0,(160*4+40,a3)
	and.l d0,(160*4+80,a3)
	and.l d0,(160*4+120,a3)
	
	and.l d0,(160*5,a3)
	and.l d0,(160*5+40,a3)
	and.l d0,(160*5+80,a3)
	and.l d0,(160*5+120,a3)
	
	and.l d0,(160*6,a3)
	and.l d0,(160*6+40,a3)
	and.l d0,(160*6+80,a3)
	and.l d0,(160*6+120,a3)
	
	and.l d0,(160*7,a3)
	and.l d0,(160*7+40,a3)
	and.l d0,(160*7+80,a3)
	and.l d0,(160*7+120,a3)

	move.l #160,d3				;Width of a line in bytes
	move.l #(8)-1,d1			;Line count for DBRA
	rts

	
	
	
drawtileadvancedS:
	and.b #%00000110,d0			;%-NNBBXYP
	beq drawtilecustomS			;X,Y flip 0 = special prog
			
	move.b (a2),d0
	and.b #%11111110,d0			;Clear Update Flag
	move.b d0,(a2)
	addq.l #1,a2

	ifd tiletest_noflip	;for minimal testing
		bra drawtilebasiconly
	endif

	clr.l D2
	and.b #%11110000,d0	;nnnn---
	move.b d0,D2
	
	clr.l d0
	move.b (a2),d0		;%NNNNNNNN
	subq.l #1,a2
	
	asl.l #8,d0
	or.w d0,D2			;NNNNNNNN nnnn----
	
	asl.l #1,d2			;32 bytes per tile
	add.l a1,D2			;Add Tile Base
	move.l d2,a0
		
		
	move.b (a2),d0
	addq.l #2,a2	
	btst #2,d0			;Yflip?
	bne drawtileyflipS

drawtilexflipS:
	move.l a1,-(sp)
		jsr ShiftPrep		;Perform a shift
	
		move.l #FlipLUT,a1	;Xflip Lookup Table
			
DrawTileNextLineRevS:	
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		move.b (a1,d0),d0	;Convert via LUT
		lsl.l d4,d0			;Apply Pixel shift
		or.l d0,(a3)		;OR it to the screen
		
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		move.b (a1,d0),d0	;Convert via LUT
		lsl.l d4,d0			;Apply Pixel shift
		or.l d0,(40,a3)		;OR it to the screen
			
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		move.b (a1,d0),d0	;Convert via LUT
		lsl.l d4,d0			;Apply Pixel shift
		or.l d0,(80,a3)		;OR it to the screen
		
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		move.b (a1,d0),d0	;Convert via LUT
		lsl.l d4,d0			;Apply Pixel shift
		or.l d0,(120,a3)	;OR it to the screen

		add.l d3,a3		;Down one pixel line
		
		dbra d1,DrawTileNextLineRevS
	move.l (sp)+,a1
	move.l d2,a3
	jmp tiledone

	
drawtilexyflipS:
	move.l a1,-(sp)
	jsr ShiftPrep		
		move.l #FlipLUT,a1
		add.l #4*8,a0		;Move to last source byte
			
DrawTileNextLineRevYS:	
		clr.l d0
		move.b -(a0),d0		;Get last byte
		move.b (a1,d0),d0	;X-flip it
		lsl.l d4,d0
		or.l d0,(120,a3)	;Bitplane 3
	
		clr.l d0
		move.b -(a0),d0		;Get last byte
		move.b (a1,d0),d0	;X-flip it
		lsl.l d4,d0
		or.l d0,(80,a3)		;Bitplane 2
		
		clr.l d0
		move.b -(a0),d0		;Get last byte
		move.b (a1,d0),d0	;X-flip it
		lsl.l d4,d0
		or.l d0,(40,a3)		;Bitplane 1
		
		clr.l d0
		move.b -(a0),d0		;Get last byte
		move.b (a1,d0),d0	;X-flip it
		lsl.l d4,d0
		or.l d0,(a3)		;Bitplane 0
		
		add.l d3,a3			;Next vram line
		dbra d1,DrawTileNextLineRevYS
	move.l (sp)+,a1
	move.l d2,a3
	jmp tiledone

	
	
drawtileyflipS:
	btst #3,d0				;XY flipping?
	bne drawtilexyflipS
		
	jsr ShiftPrep
		add.l #160*7,a3		;Move to last screen line
drawtilebasiconlySLY:	
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		lsl.l d4,d0			;Shift it
		or.l d0,(a3)		;Draw to screen
	
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		lsl.l d4,d0			;Shift it
		or.l d0,(40,a3)		;Draw to screen
		
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		lsl.l d4,d0			;Shift it
		or.l d0,(80,a3)		;Draw to screen
		
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		lsl.l d4,d0			;Shift it
		or.l d0,(120,a3)	;Draw to screen
		
		sub.l d3,a3			;Up a line
		dbra d1,drawtilebasiconlySLY
	move.l d2,a3
	jmp tiledone

	
drawtileemptyS:
	addq.l #1,a2
	move.b (a2),d0
	addq.l #1,a2

	cmp.b #255,d0	;255=empty <255=tilenum
	bne drawtiletranspS
	jmp tiledone
	
	
	
;;;;;;;;;;;;;;;;;;transparent


drawtiletranspS:
	move.b d0,d2
	
	lsl.l #5,d2		;32 bytes per tile
	
	add.l a1,D2			;Add Tile Base
	move.l d2,a0

;Copied from ShiftPrep
	bclr #3,d4			;ensure bit 3 cleared in shift 
	
	move.l a3,d2		;Backup A3
	move.l d2,d0
	btst #0,d0			;Even byte vram Dest?
	bne NoBottomBitSP		;Were working in 16 bit pairs.
	bset #3,d4			;Yes, then we'll shift 8 bits left
NoBottomBitSP:	
	bclr #0,d0			;Move to word aligned pos
	move.l d0,a3
	
	subq.l #2,a3		;Compensate for the fact we read/write longs
		
	move.l #160,d3		;Line width (bytes)
	move.l #(8)-1,d1	;line count for DBRA
		
	
DrawTileNextLineTS:			;A6=Vram Dest
		move.l #$FFFFFF00,d6
		move.b (a0),d6		;Build the mask
		or.b (1,a0),d6
		or.b (2,a0),d6
		or.b (3,a0),d6
		not.b d6			;Bit 1=keep background
							;Bit 0=Remove background (tile)
		rol.l d4,d6
		
		clr.l d0	
		move.b (a0)+,d0		;Get source pattern
		lsl.l d4,d0			;Shift it
		and.l d6,(a3)		;Mask background
		or.l d0,(a3)		;Bitplane 0

		clr.l d0			
		move.b (a0)+,d0		;Get source pattern
		lsl.l d4,d0			;Shift it
		and.l d6,(40,a3)	;Mask background
		or.l d0,(40,a3)		;Bitplane 1
		
		clr.l d0	
		move.b (a0)+,d0		;Get source pattern
		lsl.l d4,d0			;Shift it
		and.l d6,(80,a3)	;Mask background
		or.l d0,(80,a3)		;Bitplane 2

		clr.l d0	
		move.b (a0)+,d0		;Get source pattern
		lsl.l d4,d0			;Shift it
		and.l d6,(120,a3)	;Mask background
		or.l d0,(120,a3)	;Bitplane 3
	
		add.l d3,a3			;Down a VRAM line
		dbra d1,DrawTileNextLineTS	;Next line
	move.l d2,a3			;Restore VRAM pos
	jmp tiledone

	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

drawtilecustomS:
	move.b (a2),d0				;%NNcc----
	and.b #%11111110,d0
	move.b d0,(a2)

	lsl.l #2,d0					;%NN --------
	and.l #%0000001100000000,d0
	move.l d0,D2

	move.b (a2),d0
	and.b #%11111110,d0
	move.b d0,(a2)
	and.b #%00110000,d0			;cmd bits
	bne notdrawtilefillS
		jmp drawtilefillS
notdrawtilefillS:

	cmp.b #%00110000,d0
	beq drawtileemptyS

	
drawtiledoubleS:
	addq.l #1,a2
	move.b (a2),D2				;------NN nnnnnnnn - tile number
	addq.l #1,a2
	
	asl.l #4,d2				;Tilenum *16
	add.l a1,D2				;Add Tile Base
	move.l d2,a0
		
	jsr ShiftPrep			;Prepare shift
	
		asl.l #1,d3			;320 bytes per 2 lines
		move.w #3,d1		;Line Count -1
		
DrawTileNextLineDS:		
		clr.l d0
		move.b (a0)+,d0		;Source pattern
		lsl.l d4,d0			;Shift it
		or.l d0,(a3)			;Bitplane 0
		or.l d0,(160,a3)		;Bitplane 0
		
		clr.l d0
		move.b (a0)+,d0		;Source pattern
		lsl.l d4,d0			;Shift it
		or.l d0,(40,a3)			;Bitplane 1
		or.l d0,(160+40,a3)		;Bitplane 1
		
		clr.l d0
		move.b (a0)+,d0		;Source pattern
		lsl.l d4,d0			;Shift it
		or.l d0,(80,a3)			;Bitplane 2
		or.l d0,(160+80,a3)		;Bitplane 2
		
		clr.l d0
		move.b (a0)+,d0		;Source pattern
		lsl.l d4,d0			;Shift it
		or.l d0,(120,a3)		;Bitplane 3
		or.l d0,(160+120,a3)	;Bitplane 3
				
		add.l d3,a3				;Down a VRAM line
		dbra d1,DrawTileNextLineDS	;Next line
		
	move.l d2,a3		;Restore Vram Dest
	jmp tiledone

	
drawtilefillS:
	addq.l #1,a2
	move.b (a2),D2	;------bb nnnnnnnn - tile number
	addq.l #1,a2

	asl.b #2,d2				;4 bytes per fill
	add.l #patternFill,D2
	move.l d2,a0
	
	jsr ShiftPrep			;prep background
			
DrawTileNextLineFS:			;A3=Vram Dest
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		lsl.l d4,d0			;pixels Shift 
		or.l d0,(a3)
		or.l d0,(160*1,a3)	;Draw 8 lines - bitplane 0
		or.l d0,(160*2,a3)
		or.l d0,(160*3,a3)
		or.l d0,(160*4,a3)
		or.l d0,(160*5,a3)
		or.l d0,(160*6,a3)
		or.l d0,(160*7,a3)
		
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		lsl.l d4,d0			;pixels Shift 
		or.l d0,(40,a3)
		or.l d0,(160*1+40,a3)	;Draw 8 lines - bitplane 1
		or.l d0,(160*2+40,a3)
		or.l d0,(160*3+40,a3)
		or.l d0,(160*4+40,a3)
		or.l d0,(160*5+40,a3)
		or.l d0,(160*6+40,a3)
		or.l d0,(160*7+40,a3)
		
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		lsl.l d4,d0			;pixels Shift 
		or.l d0,(80,a3)
		or.l d0,(160*1+80,a3)	;Draw 8 lines - bitplane 2
		or.l d0,(160*2+80,a3)
		or.l d0,(160*3+80,a3)
		or.l d0,(160*4+80,a3)
		or.l d0,(160*5+80,a3)
		or.l d0,(160*6+80,a3)
		or.l d0,(160*7+80,a3)
		
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		lsl.l d4,d0			;pixels Shift 
		or.l d0,(120,a3)
		or.l d0,(160*1+120,a3)	;Draw 8 lines - bitplane 3
		or.l d0,(160*2+120,a3)
		or.l d0,(160*3+120,a3)
		or.l d0,(160*4+120,a3)
		or.l d0,(160*5+120,a3)
		or.l d0,(160*6+120,a3)
		or.l d0,(160*7+120,a3)
		
	move.l d2,a3	;Restore Vram Dest
	jmp tiledone
