

;A0 A1 A2 A3
;D0 D1 D2

;A4=IX
;A2=Tilemap A1=TileOffset A3=Vram dest
			
drawtile:
	ifd drawtileShifted			;For part tile X-shift
		move.l a3,d2
		and.l #$C0000000,d2		;Need xshift?
		bne drawtileShifted		
	endif
	
	btst #0,d0			;%-NNBBXYP U
	
	ifnd tiletest_basiconly		;for minimal testing
		bne drawtileadvanced
	endif
	
	asl.b #1,d0			;%NNBBXYP0 ... Update flag cleared (bit 0)
	move.b d0,(a2)+

drawtilebasiconly:
	and.b #%11110000,d0	;%nnnn----

	clr.l D2
	move.b d0,D2
	
	clr.l d0
	move.b (a2)+,d0		;%NNNNNNNN
	
	asl.l #8,d0
	or.w d0,D2			;NNNNNNNN nnnn----
	
	lsl.l #1,d2			;32 bytes per tile
	add.l a1,D2			;Add Tile Base
	move.l d2,a0

	
	move.b (a0)+,(a3)		;Bitplane 0
	move.b (a0)+,(2,a3)		;Bitplane 1
	move.b (a0)+,(4,a3)		;Bitplane 2
	move.b (a0)+,(6,a3)		;Bitplane 3
	
	move.b (a0)+,(160*1+0,a3)	;Bitplane 0
	move.b (a0)+,(160*1+2,a3)	;Bitplane 1
	move.b (a0)+,(160*1+4,a3)	;Bitplane 2
	move.b (a0)+,(160*1+6,a3)	;Bitplane 3
	
	move.b (a0)+,(160*2+0,a3)	;Bitplane 0
	move.b (a0)+,(160*2+2,a3)	;Bitplane 1
	move.b (a0)+,(160*2+4,a3)	;Bitplane 2
	move.b (a0)+,(160*2+6,a3)	;Bitplane 3
	
	move.b (a0)+,(160*3+0,a3)	;Bitplane 0
	move.b (a0)+,(160*3+2,a3)	;Bitplane 1
	move.b (a0)+,(160*3+4,a3)	;Bitplane 2
	move.b (a0)+,(160*3+6,a3)	;Bitplane 3
	
	move.b (a0)+,(160*4+0,a3)	;Bitplane 0
	move.b (a0)+,(160*4+2,a3)	;Bitplane 1
	move.b (a0)+,(160*4+4,a3)	;Bitplane 2
	move.b (a0)+,(160*4+6,a3)	;Bitplane 3
	
	move.b (a0)+,(160*5+0,a3)	;Bitplane 0
	move.b (a0)+,(160*5+2,a3)	;Bitplane 1
	move.b (a0)+,(160*5+4,a3)	;Bitplane 2
	move.b (a0)+,(160*5+6,a3)	;Bitplane 3
	
	move.b (a0)+,(160*6+0,a3)	;Bitplane 0
	move.b (a0)+,(160*6+2,a3)	;Bitplane 1
	move.b (a0)+,(160*6+4,a3)	;Bitplane 2
	move.b (a0)+,(160*6+6,a3)	;Bitplane 3
	
	move.b (a0)+,(160*7+0,a3)	;Bitplane 0
	move.b (a0)+,(160*7+2,a3)	;Bitplane 1
	move.b (a0)+,(160*7+4,a3)	;Bitplane 2
	move.b (a0)+,(160*7+6,a3)	;Bitplane 3
	
	jmp tiledone


drawtileadvanced:
	and.b #%00000110,d0			;%-NNBBXYP
	beq drawtilecustom			;X,Y flip 0 = special prog
	
	move.b (a2),d0
	and.b #%11111110,d0			;Clear Update Flag
	move.b d0,(a2)+

	ifd tiletest_noflip	;for minimal testing
		bra drawtilebasiconly
	endif

	clr.l D2
	and.b #%11110000,d0		;%nnnn----
	move.b d0,D2
	
	clr.l d0
	move.b (a2),d0			;%NNNNNNNN
	subq.l #1,a2
	
	asl.l #8,d0
	or.w d0,D2				;NNNNNNNN nnnn----
	
	asl.l #1,d2				;32 bytes per tile
	
	add.l a1,D2				;Add Tile Base
	move.l d2,a0
	
	move.l a3,d2			;Backup VRAM pos
		
	move.b (a2),d0
	addq.l #2,a2
	
	btst #2,d0
	bne drawtileyflip

drawtilexflip:
	move.l a1,-(sp)
		move.l #FlipLUT,a1	;Xflip Lookup Table
		move.l #160,d3		;Bytes per line
		
		move.w #7,d1		;Line Count -1
		clr.l d0
		
DrawTileNextLineRev:	
		move.b (a0)+,d0		;Get a source byte
		move.b (a1,d0),d0	;Convert via LUT
		move.b d0,(a3)		;Bitplane 0
		
		move.b (a0)+,d0		;Get a source byte
		move.b (a1,d0),d0	;Convert via LUT
		move.b d0,(2,a3)	;Bitplane 1
			
		move.b (a0)+,d0		;Get a source byte
		move.b (a1,d0),d0	;Convert via LUT
		move.b d0,(4,a3)	;Bitplane 2
		
		move.b (a0)+,d0		;Get a source byte
		move.b (a1,d0),d0	;Convert via LUT
		move.b d0,(6,a3)	;Bitplane 3

		add.l d3,a3			;Down one pixel line
		dbra d1,DrawTileNextLineRev

	move.l (sp)+,a1
	move.l d2,a3			;Restore VRAM pos
	jmp tiledone

	
drawtilexyflip:	
	move.l a1,-(sp)
		move.l #FlipLUT,a1	;Xflip Lookup Table
		move.l #160,d3		;Bytes per line
		
		add.l #4*8,a0		;Move to last line
		move.w #7,d1		;Line Count -1
		clr.l d0		
		
DrawTileNextLineRevY:	
		move.b -(a0),d0
		move.b (a1,d0),d0
		move.b d0,(6,a3)	;Bitplane 0
			
		move.b -(a0),d0
		move.b (a1,d0),d0
		move.b d0,(4,a3)	;Bitplane 1
		
		move.b -(a0),d0
		move.b (a1,d0),d0
		move.b d0,(2,a3)	;Bitplane 2
		
		move.b -(a0),d0
		move.b (a1,d0),d0
		move.b d0,(a3)		;Bitplane 3
		
		add.l d3,a3
	dbra d1,DrawTileNextLineRevY	;Next line

	move.l (sp)+,a1
	move.l d2,a3			;Restore VRAM pos
	jmp tiledone

	
drawtileyflip:
	btst #3,d0
	bne drawtilexyflip

	move.b (a0)+,(160*7+0,a3)	;Bitplane 0
	move.b (a0)+,(160*7+2,a3)	;Bitplane 1
	move.b (a0)+,(160*7+4,a3)	;Bitplane 2
	move.b (a0)+,(160*7+6,a3)	;Bitplane 3
	
	move.b (a0)+,(160*6+0,a3)	;Bitplane 0
	move.b (a0)+,(160*6+2,a3)	;Bitplane 1
	move.b (a0)+,(160*6+4,a3)	;Bitplane 2
	move.b (a0)+,(160*6+6,a3)	;Bitplane 3
	
	move.b (a0)+,(160*5+0,a3)	;Bitplane 0
	move.b (a0)+,(160*5+2,a3)	;Bitplane 1
	move.b (a0)+,(160*5+4,a3)	;Bitplane 2
	move.b (a0)+,(160*5+6,a3)	;Bitplane 3
	
	move.b (a0)+,(160*4+0,a3)	;Bitplane 0
	move.b (a0)+,(160*4+2,a3)	;Bitplane 1
	move.b (a0)+,(160*4+4,a3)	;Bitplane 2
	move.b (a0)+,(160*4+6,a3)	;Bitplane 3
	
	move.b (a0)+,(160*3+0,a3)	;Bitplane 0
	move.b (a0)+,(160*3+2,a3)	;Bitplane 1
	move.b (a0)+,(160*3+4,a3)	;Bitplane 2
	move.b (a0)+,(160*3+6,a3)	;Bitplane 3
	
	move.b (a0)+,(160*2+0,a3)	;Bitplane 0
	move.b (a0)+,(160*2+2,a3)	;Bitplane 1
	move.b (a0)+,(160*2+4,a3)	;Bitplane 2
	move.b (a0)+,(160*2+6,a3)	;Bitplane 3
	
	move.b (a0)+,(160*1+0,a3)	;Bitplane 0
	move.b (a0)+,(160*1+2,a3)	;Bitplane 1
	move.b (a0)+,(160*1+4,a3)	;Bitplane 2
	move.b (a0)+,(160*1+6,a3)	;Bitplane 3
	
	move.b (a0)+,(a3)	;Bitplane 0
	move.b (a0)+,(2,a3)	;Bitplane 1
	move.b (a0)+,(4,a3)	;Bitplane 2
	move.b (a0)+,(6,a3)	;Bitplane 3

	jmp tiledone
	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

drawtileempty:
	addq.l #1,a2
	move.b (a2)+,d0
	cmp.b #255,d0			;255=empty <255=tilenum
	bne drawtiletransp
	jmp tiledone
	
;;;;;;;;;;;;;;;;;;transparent

drawtiletransp:
	move.b d0,d2
	
	lsl.l #5,d2			;32 bytes per tile

	add.l a1,D2			;Add Tile Base
	
	move.l d2,a0
	move.l a3,d2		;Backup VRAM pos
	
		move.w #7,d1		;Line Count -1
		clr.l d0
	
		move.l #160,d3		;Width of line in bytes
		
DrawTileNextLineT:			;A3=Vram Dest
	
		move.b (a0),d0		;Combine bitplanes into mask
		or.b (1,a0),d0
		or.b (2,a0),d0
		or.b (3,a0),d0
		not.b d0			;Flip mask to form cutout
		
		and.b d0,(a3)		;Cut out area for pattern
		and.b d0,(2,a3)
		and.b d0,(4,a3)
		and.b d0,(6,a3)
	
	
		move.b (a0)+,d0
		or.b d0,(a3)		;Bitplane 0
		move.b (a0)+,d0
		or.b d0,(2,a3)		;Bitplane 1
		move.b (a0)+,d0
		or.b d0,(4,a3)		;Bitplane 2
		move.b (a0)+,d0
		or.b d0,(6,a3)		;Bitplane 3
	
		add.l d3,a3			;Down a VRAM line
		
		dbra d1,DrawTileNextLineT	;Next line
	
	move.l d2,a3			;Restore VRAM pos
	jmp tiledone

	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

drawtilecustom:
	move.b (a2),d0			;%NNcc----
	and.b #%11111110,d0
	move.b d0,(a2)

	lsl.l #2,d0				;%NN --------
	and.l #%0000001100000000,d0
	move.l d0,D2

	move.b (a2),d0
	and.b #%11111110,d0
	move.b d0,(a2)
	and.b #%00110000,d0		;cmd bits
	bne notdrawtilefill
		jmp drawtilefill
notdrawtilefill:

	cmp.b #%00110000,d0
	beq drawtileempty

	
drawtiledouble:
	addq.l #1,a2
	move.b (a2)+,D2			;------NN nnnnnnnn - tile number
		
	asl.l #4,d2				;Tilenum *16
	
	add.l a1,D2				;Add Tile Base
	
	move.l d2,a0
	move.l a3,d2			;Backup VRAM pos
	
		move.l #160*2,d3
		move.w #3,d1		;Line Count -1
		
DrawTileNextLineD:			;A3=Vram Dest
				
		move.b (a0),(a3)		;Bitplane 0
		move.b (a0)+,(160,a3)	;Bitplane 0
		move.b (a0),(2,a3)		;Bitplane 1
		move.b (a0)+,(160+2,a3)	;Bitplane 1
		move.b (a0),(4,a3)		;Bitplane 2
		move.b (a0)+,(160+4,a3)	;Bitplane 2
		move.b (a0),(6,a3)		;Bitplane 3
		move.b (a0)+,(160+6,a3)	;Bitplane 3
			
		add.l d3,a3				;Down a VRAM line
		dbra d1,DrawTileNextLineD	;Next line
	
	move.l d2,a3			;Restore VRAM pos
	jmp tiledone

	
drawtilefill:
	addq.l #1,a2
	move.b (a2)+,D2	;------NN nnnnnnnn - tile number
	
	asl.b #2,d2				;4 bytes per fill
	add.l #patternFill,D2
	move.l d2,a0
		
	move.l d2,a0
		
DrawTileNextLineF:			;A3=Vram Dest
	move.b (a0)+,d0
	move.b d0,(a3)			;Bitplane 0
	move.b d0,(160*1,a3)
	move.b d0,(160*2,a3)
	move.b d0,(160*3,a3)
	move.b d0,(160*4,a3)
	move.b d0,(160*5,a3)
	move.b d0,(160*6,a3)
	move.b d0,(160*7,a3)
	
	move.b (a0)+,d0
	move.b d0,(2,a3)		;Bitplane 1
	move.b d0,(160*1+2,a3)
	move.b d0,(160*2+2,a3)
	move.b d0,(160*3+2,a3)
	move.b d0,(160*4+2,a3)
	move.b d0,(160*5+2,a3)
	move.b d0,(160*6+2,a3)
	move.b d0,(160*7+2,a3)
	
	move.b (a0)+,d0
	move.b d0,(4,a3)		;Bitplane 2
	move.b d0,(160*1+4,a3)
	move.b d0,(160*2+4,a3)
	move.b d0,(160*3+4,a3)
	move.b d0,(160*4+4,a3)
	move.b d0,(160*5+4,a3)
	move.b d0,(160*6+4,a3)
	move.b d0,(160*7+4,a3)
	
	move.b (a0)+,d0
	move.b d0,(6,a3)		;Bitplane 3
	move.b d0,(160*1+6,a3)
	move.b d0,(160*2+6,a3)
	move.b d0,(160*3+6,a3)
	move.b d0,(160*4+6,a3)
	move.b d0,(160*5+6,a3)
	move.b d0,(160*6+6,a3)
	move.b d0,(160*7+6,a3)
	
	jmp tiledone

	
	
	ifnd drawtileShifted	;Use alternate shifted versions?
	
	
;4 words for 4 bitplanes are concecutive in memory, eg: $0000111122223333

;Addr = ScreenBase + 4*4 (YposInLines * 160) + (XposInTiles & $FE)*8 + (XposInTiles & $01)

;d1=x d4=y (Logical Units) - returns screen address in A3

GetScreenPos: 
	move.l (ScreenBase),a3 	;Get screen pointer into a3
	add.l #4*4,a3			;Centre screen

	and.l #$FF,d1
	lsr.b #2,d1				;Convert Xpos to tiles
	move.l d1,d0	
	and.l #%11111110,d1	 	;Offset in Words
	and.l #%00000001,d0	 	;Byte offset (1 tile)
	rol.l #2,d1			 	;4 Bitplane words consecutive in memory
	add.l d1,a3				;Add Word offset
	add.l d0,a3				;Add Byte offset
	
	mulu #160*2,d4			;160 bytes per Y line
	add.l d4,a3	
	rts
		
	endif
	
	
		