;This version does tile shifts where the whole shifted tile is in the bitplane.


GetScreenPos: ; d4=x d4=y - returns screen address in A6
	and.l #$FF,d1
	move.l (ScreenBase),a3 	;Get screen pointer into a6
	
	move.l d1,d0	
	and.l #%00000011,d0		;Shift
	eor.b #%00000011,d0
	ror.l #2,d0				;Shift to top 2 bits %SS-----...
	add.l d0,a3				;Add X shift 
	
	lsr.b #2,d1				;Convert Xpos to tiles
	
	move.l d1,d0	
	and.l #%11111110,d1	 	;Offset in Words
	and.l #%00000001,d0	 	;Byte offset (1 tile)
	rol.l #2,d1			 	;4 Bitplane words consecutive in memory
	add.l d1,a3				;Add Word offset
	add.l d0,a3				;Add Byte offset
	
	add.l #4*4,a3			;Centre screen
	
	mulu #160*2,d4			 ;160 bytes per Y line
	add.l d4,a3
	rts
		

	
;A0 A1 A2 A3
;D0 D1 D2

;A4=IX
;A2=Tilemap A1=TileOffset A3=Vram dest
;D4= shift amount in bits.
			
drawtileShifted:
	move.l a3,d2
	btst #0,d2				;Need to span bitplane?
	beq drawtileShifted2	;Second half of bitplane words
	
	btst #0,d0				;%-NNBBXYP U
	
	ifnd tiletest_basiconly		;for minimal testing
		bne drawtileadvancedS
	endif
	
	asl.b #1,d0
	move.b d0,(a2)+
	

drawtilebasiconlyS:
	and.b #%11110000,d0		;%nnnn----

	clr.l D2
	move.b d0,D2
	
	clr.l d0
	move.b (a2)+,d0		;%NNNNNNNN
		
	asl.l #8,d0
	or.l d0,D2			;NNNNNNNN nnnn----
	
	lsl.l #1,d2			;32 bytes per tile
	add.l a1,D2			;Add Tile Base
	move.l d2,a0
	
	jsr ShiftPrep		;Perform shift and clear tile area
	
	
drawtilebasiconlySL:	
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		lsl.w d4,d0			;Shift it
		or.w d0,(a3)		;Write it to the screen
	
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		lsl.w d4,d0			;Shift it
		or.w d0,(2,a3)		;Write it to the screen
		
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		lsl.w d4,d0			;Shift it
		or.w d0,(4,a3)		;Write it to the screen
		
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		lsl.w d4,d0			;Shift it
		or.w d0,(6,a3)		;Write it to the screen
		
		add.l d3,a3			;Down a line
		dbra d1,drawtilebasiconlySL

	move.l d2,a3			;Restore VRAM pos
	jmp tiledone

	
ShiftPrep:
	move.l a3,d2	;Backup A3
	
	;bclr #3,d4
	move.l d2,d0
	subq.l #1,d0	;Move to previous tile
	bclr #0,d0		;round to bitplane
	move.l d0,a3	;Back into A3
	
	move.l #$FFFFFF00,d0	;Clear Tile Mask
	rol.l d4,d0	
	
;Clear the tile we're about to replace	
	and.w d0,(a3)
	and.w d0,(2,a3)
	and.w d0,(4,a3)
	and.w d0,(6,a3)
	
	and.w d0,(160*1,a3)
	and.w d0,(160*1+2,a3)
	and.w d0,(160*1+4,a3)
	and.w d0,(160*1+6,a3)
	
	and.w d0,(160*2,a3)
	and.w d0,(160*2+2,a3)
	and.w d0,(160*2+4,a3)
	and.w d0,(160*2+6,a3)
	
	and.w d0,(160*3,a3)
	and.w d0,(160*3+2,a3)
	and.w d0,(160*3+4,a3)
	and.w d0,(160*3+6,a3)
	
	and.w d0,(160*4,a3)
	and.w d0,(160*4+2,a3)
	and.w d0,(160*4+4,a3)
	and.w d0,(160*4+6,a3)
	
	and.w d0,(160*5,a3)
	and.w d0,(160*5+2,a3)
	and.w d0,(160*5+4,a3)
	and.w d0,(160*5+6,a3)
	
	and.w d0,(160*6,a3)
	and.w d0,(160*6+2,a3)
	and.w d0,(160*6+4,a3)
	and.w d0,(160*6+6,a3)
	
	and.w d0,(160*7,a3)
	and.w d0,(160*7+2,a3)
	and.w d0,(160*7+4,a3)
	and.w d0,(160*7+6,a3)

	move.l #160,d3		;Screen Width in bytes
	move.l #8-1,d1		;Tile height (for loop count)
	rts

	
	
	
drawtileadvancedS:
	and.b #%00000110,d0
	beq drawtilecustomS
	
		
	move.b (a2),d0
	and.b #%11111110,d0
	move.b d0,(a2)+
	

	ifd tiletest_noflip	;for minimal testing
		bra drawtilebasiconly
	endif

	clr.l D2
	and.b #%11110000,d0	;nnnn---
	move.b d0,D2
	
	clr.l d0
	move.b (a2),d0
	subq.l #1,a2
	
	asl.l #8,d0
	or.l d0,D2	;NNNNNNNN nnnn----
	
	asl.l #1,d2
	add.l a1,D2			;Add Tile Base
	move.l d2,a0
	
	;move.l a3,d2		;Not needed 
		
	move.b (a2),d0
	addq.l #2,a2
	
	btst #2,d0
	bne drawtileyflipS

drawtilexflipS:
	move.l a1,-(sp)
		
		jsr ShiftPrep

		move.l #FlipLUT,a1	;Xflip Lookup Table			
DrawTileNextLineRevS:	
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		move.b (a1,d0),d0	;Convert via LUT
		lsl.w d4,d0
		or.w d0,(a3)
		
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		move.b (a1,d0),d0	;Convert via LUT
		lsl.w d4,d0
		or.w d0,(2,a3)
			
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		move.b (a1,d0),d0	;Convert via LUT
		lsl.w d4,d0
		or.w d0,(4,a3)
		
		clr.l d0
		move.b (a0)+,d0		;Get a source byte
		move.b (a1,d0),d0	;Convert via LUT
		lsl.w d4,d0
		or.w d0,(6,a3)

		add.l d3,a3		;Down one pixel line
		
		dbra d1,DrawTileNextLineRevS

	move.l (sp)+,a1
	move.l d2,a3			;Restore VRAM pos
	jmp tiledone

drawtilexyflipS:
		
	move.l a1,-(sp)
		

		jsr ShiftPrep
		
		move.l #FlipLUT,a1
		add.l #4*8,a0
				
DrawTileNextLineRevYS:	
			clr.l d0
			move.b -(a0),d0
			move.b (a1,d0),d0
			lsl.w d4,d0
			or.w d0,(6,a3)	;Bitplane 0
		
			clr.l d0
			move.b -(a0),d0
			move.b (a1,d0),d0
			lsl.w d4,d0
			or.w d0,(4,a3)	;Bitplane 1
			
			clr.l d0
			move.b -(a0),d0
			move.b (a1,d0),d0
			lsl.w d4,d0
			or.w d0,(2,a3)	;Bitplane 2
			
			clr.l d0
			move.b -(a0),d0
			move.b (a1,d0),d0
			lsl.w d4,d0
			or.w d0,(a3)	;Bitplane 3
			
			add.l d3,a3
		dbra d1,DrawTileNextLineRevYS		;Next line


	move.l (sp)+,a1
	move.l d2,a3			;Restore VRAM pos

	jmp tiledone

drawtileyflipS:
	btst #3,d0
	bne drawtilexyflipS
	
	
	jsr ShiftPrep
	
	
		add.l #160*7,a3
	
	
drawtilebasiconlySLY:	
		clr.l d0
		move.b (a0)+,d0
		lsl.w d4,d0
		or.w d0,(a3)
	
		clr.l d0
		move.b (a0)+,d0
		lsl.w d4,d0
		or.w d0,(2,a3)
		
		clr.l d0
		move.b (a0)+,d0
		lsl.w d4,d0
		or.w d0,(4,a3)
		
		clr.l d0
		move.b (a0)+,d0
		lsl.w d4,d0
		or.w d0,(6,a3)
		
		sub.l d3,a3
		dbra d1,drawtilebasiconlySLY

		move.l d2,a3			;Restore VRAM pos
		jmp tiledone

drawtileemptyS:
;                                     		inc bc
	addq.l #1,a2
;                                     		ld a,(bc)	;255=empty <255=tilenum
	move.b (a2)+,d0
	

	cmp.b #255,d0
	bne drawtiletranspS
	jmp tiledone
;;;;;;;;;;;;;;;;;;transparent

drawtiletranspS:
	move.b d0,d2
	lsl.l #5,d2		;32 bytes per tile
	
	add.l a1,D2			;Add Tile Base
	
	move.l d2,a0
	
;ShiftPrep
	move.l a3,d2
		move.l d2,d0
		bclr #0,d0
		move.l d0,a3
			
		move.l #160,d3	
		move.l #(8)-1,d1	
			
DrawTileNextLineTS:			;A6=Vram Dest
		
		move.l #$FFFFFF00,d6
		move.b (a0),d6
		or.b (1,a0),d6
		or.b (2,a0),d6
		or.b (3,a0),d6
			
		not.b d6
		
		rol.l d4,d6

		clr.l d0
		move.b (a0)+,d0
		lsl.w d4,d0
		and.w d6,(a3)
		or.w d0,(a3)		;Bitplane 0
		
		clr.l d0
		move.b (a0)+,d0
		lsl.w d4,d0
		and.w d6,(2,a3)
		or.w d0,(2,a3)		;Bitplane 1
		
		clr.l d0
		move.b (a0)+,d0
		lsl.w d4,d0
		and.w d6,(4,a3)
		or.w d0,(4,a3)		;Bitplane 2
		
		clr.l d0
		move.b (a0)+,d0
		lsl.w d4,d0
		and.w d6,(6,a3)
		or.w d0,(6,a3)		;Bitplane 3
	
		add.l d3,a3	;Down a VRAM line
		
		dbra d1,DrawTileNextLineTS	;Next line
	
	move.l d2,a3			;Restore VRAM pos
	jmp tiledone

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

drawtilecustomS:
	move.b (a2),d0	;bb------
	and.b #%11111110,d0
	move.b d0,(a2)

	lsl.l #2,d0
	and.l #%0000001100000000,d0
	move.l d0,D2

	move.b (a2),d0
	and.b #%11111110,d0
	move.b d0,(a2)
	and.b #%00110000,d0	;cmd bits
	bne notdrawtilefillS
		jmp drawtilefillS
notdrawtilefillS:

	cmp.b #%00110000,d0
	beq drawtileemptyS

drawtiledoubleS:
	addq.l #1,a2
	move.b (a2)+,D2	;------bb nnnnnnnn - tile number
	
	
	asl.l #4,d2
	
	add.l a1,D2			;Add Tile Base
	
	move.l d2,a0
		
	
	jsr ShiftPrep
		asl.l #1,d3			;320 bytes per 2 lines
		move.w #3,d1		;Line Count -1
		
DrawTileNextLineDS:			;A6=Vram Dest
		
		
		clr.l d0
		move.b (a0)+,d0
		lsl.w d4,d0
		or.w d0,(a3)			;Bitplane 0
		or.w d0,(160,a3)		;Bitplane 0
		
		clr.l d0
		move.b (a0)+,d0
		lsl.w d4,d0
		or.w d0,(2,a3)			;Bitplane 1
		or.w d0,(160+2,a3)		;Bitplane 1
		
		clr.l d0
		move.b (a0)+,d0
		lsl.w d4,d0
		or.w d0,(4,a3)			;Bitplane 2
		or.w d0,(160+4,a3)		;Bitplane 2
		
		clr.l d0
		move.b (a0)+,d0
		lsl.w d4,d0
		or.w d0,(6,a3)			;Bitplane 3
		or.w d0,(160+6,a3)		;Bitplane 3
		
		
	
		add.l d3,a3	;Down a VRAM line
		
		dbra d1,DrawTileNextLineDS	;Next line
	
		move.l d2,a3			;Restore VRAM pos
	
	jmp tiledone

drawtilefillS:
	addq.l #1,a2
	move.b (a2)+,D2	;------bb nnnnnnnn - tile number
	

	asl.b #2,d2
	add.l #patternFill,d2
	move.l d2,a0
	
	
	jsr ShiftPrep
	
	
		
DrawTileNextLineFS:			;A6=Vram Dest
		clr.l d0
		move.b (a0)+,d0
		lsl.w d4,d0
		or.w d0,(a3)
		or.w d0,(160*1,a3)
		or.w d0,(160*2,a3)
		or.w d0,(160*3,a3)
		or.w d0,(160*4,a3)
		or.w d0,(160*5,a3)
		or.w d0,(160*6,a3)
		or.w d0,(160*7,a3)
		
		clr.l d0
		move.b (a0)+,d0
		lsl.w d4,d0
		or.w d0,(2,a3)
		or.w d0,(160*1+2,a3)
		or.w d0,(160*2+2,a3)
		or.w d0,(160*3+2,a3)
		or.w d0,(160*4+2,a3)
		or.w d0,(160*5+2,a3)
		or.w d0,(160*6+2,a3)
		or.w d0,(160*7+2,a3)
		
		clr.l d0
		move.b (a0)+,d0
		lsl.w d4,d0
		or.w d0,(4,a3)
		or.w d0,(160*1+4,a3)
		or.w d0,(160*2+4,a3)
		or.w d0,(160*3+4,a3)
		or.w d0,(160*4+4,a3)
		or.w d0,(160*5+4,a3)
		or.w d0,(160*6+4,a3)
		or.w d0,(160*7+4,a3)
		
		clr.l d0
		move.b (a0)+,d0
		lsl.w d4,d0
		or.w d0,(6,a3)
		or.w d0,(160*1+6,a3)
		or.w d0,(160*2+6,a3)
		or.w d0,(160*3+6,a3)
		or.w d0,(160*4+6,a3)
		or.w d0,(160*5+6,a3)
		or.w d0,(160*6+6,a3)
		or.w d0,(160*7+6,a3)
		
		move.l d2,a3			;Restore VRAM pos
	
	;LPPVHTTT TTTTTTTT	   T=Tille number  H=Hflip  V=vflip  P=palette number   L=Layer (in front of /behind sprites)
	;move.w D2,(VDP_data) 
	jmp tiledone
