;VRAM=$7084 + (Xpos*32) + Ypos 

GetScreenPos: ; d1=x d4=y - returns screen address in A3
	move.l #ScreenBase,a3 	;Fix Layer: VRAM $7000+
	
	and.l #%11111100,d1  	;Xpos * 32
	asl.l #3,d1
	add.l d1,a3
	
	and.l #%11111100,d4		;Ypos * 1
	asr.l #2,d4
	add.l d4,a3
	rts
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
;A1 A2 A3 free for our use
;D0 D1 D2

;A4=IX
;A2=Tilemap A1=TileOffset A3=Vram dest
			
drawtile:
	move.l a3,d2
	move.w d2,$3C0000 	;Select VRAM destination (16 bit)

	btst #0,d0
	ifnd tiletest_basiconly		;for minimal testing
		bne drawtileadvanced
	endif
	
	asl.b #1,d0			;%NNBBXYP0 ... Update flag cleared (bit 0)
	move.b d0,(a2)+		
		
drawtilebasiconly:
	and.b #%11110000,d0	;NNNN----
	clr.l D2
	move.b d0,D2
	
	clr.l d0
	move.b (a2)+,d0		;NNNNNNNN
	
	asl.l #8,d0
	or.w d0,D2			;NNNNNNNN nnnn----
	lsr.w #4,D2 		;----NNNN NNNNnnnn
	add.l a1,D2			;Add Tile Base
	
	move.w d2,$3C0002	;tile data $PTTT - Palette / Tile
	jmp tiledone


drawtileadvanced:
	and.b #%00000110,d0	;%-NNBBXYP
	beq drawtilecustom	;X,Y flip 0 = special prog
	
	move.b (a2),d0
	and.b #%11111110,d0	;Clear Update Flag
	move.b d0,(a2)+
	
	ifd tiletest_noflip	;for minimal testing
		bra drawtilebasiconly
	endif

	clr.l D2
	and.b #%11110000,d0	;nnnn----
	move.b d0,D2
	
	clr.l d0
	move.b (a2),d0		;NNNNNNNN
	subq.l #1,a2
	
	asl.l #8,d0
	or.w d0,D2			;NNNNNNNN nnnn----
	
	lsr.w #4,D2
	add.l a1,D2			;Add Tile Base
	
	move.b (a2),d0
	addq.l #2,a2

	
	btst #2,d0
	bne drawtileyflip

drawtilexflip:
	add.w #PatternXflip,d2
	move.w d2,$3C0002	;tile data $PTTT - Palette / Tile
	jmp tiledone

drawtilexyflip:
	add.w #PatternXYflip,d2
	move.w d2,$3C0002	;tile data $PTTT - Palette / Tile
	jmp tiledone

drawtileyflip:
	btst #3,d0
	bne drawtilexyflip
	
	add.w #PatternYflip,d2
	move.w d2,$3C0002	;tile data $PTTT - Palette / Tile
	jmp tiledone

	
	
drawtileempty:
	addq.l #1,a2
	move.b (a2)+,d0		;255=empty <255=tilenum
	
	cmp.b #255,d0
	bne drawtiletransp
	jmp tiledone

drawtiletransp:			;;;;;;;;;;;;;;;;;;transparent
	move.b d0,d2
	add.l a1,D2			;Add Tile Base
	move.w d2,$3C0002	;tile data $PTTT - Palette / Tile
	jmp tiledone
	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

drawtilecustom:
	move.b (a2),d0				;%NNcc----
	and.b #%11111110,d0
	move.b d0,(a2)

	lsl.l #2,d0
	and.l #%0000001100000000,d0	;%NN --------
	move.l d0,D2

	move.b (a2),d0
	and.b #%11111110,d0
	move.b d0,(a2)
	and.b #%00110000,d0		;cmd bits
	beq drawtilefill

	cmp.b #%00110000,d0
	beq drawtileempty

	
drawtiledouble:
	addq.l #1,a2
	move.b (a2)+,D2		;------NN nnnnnnnn - tile number
	
	add.l a1,D2			;Add Tile Base
	
	add.w #PatternDoubleHeight,d2
	move.w d2,$3C0002	;tile data $PTTT - Palette / Tile
	jmp tiledone

drawtilefill:
	addq.l #1,a2
	move.b (a2)+,D2		;------NN nnnnnnnn - tile number

	add.l #patternFill,D2
	move.w d2,$3C0002	;tile data $PTTT - Palette / Tile
	jmp tiledone

	
	
	
	