

;A1 A2 A3 free for our use
;D0 D1 D2

;A4=IX
;A2=Tilemap A1=TileOffset A3=Vram dest
			
drawtile:
	Move.w a3,$3C0000 		;Select VRAM ($0000+ Sprite TileAddr)
		
	btst #0,d0
	ifnd tiletest_basiconly		;for minimal testing
		bne drawtileadvanced
	endif
	
	asl.b #1,d0			;%NNBBXYP0 ... Update flag cleared (bit 0)
	move.b d0,(a2)
	addq.l #1,a2

drawtilebasiconly:
	and.b #%11110000,d0	;nnnn----
	clr.l D2
	move.b d0,D2
	
	clr.l d0
	move.b (a2),d0		;NNNNNNNN
	addq.l #1,a2
	
	asl.l #8,d0
	or.w d0,D2			;NNNNNNNN nnnn----
	
	
	lsr.w #4,D2			;----NNNN NNNNnnnn
	
	add.l a1,D2			;Add Tile Base
	
	move.w d2,$3C0002	;Write new Tilenum to address
	
	;we already set autoinc with LSPC_INCR	$3C0004
	move.w #$0100,$3C0002	;PPPPPPPP NNNNAAVH Palette Tile, 
											;  Autoanim Flip
	jmp tiledone


drawtileadvanced:
	and.b #%00000110,d0	;%-NNBBXYP
	beq drawtilecustom	;X,Y flip 0 = special prog
	
	move.b (a2),d0
	and.b #%11111110,d0
	move.b d0,(a2)+

	ifd tiletest_noflip	;for minimal testing
		bra drawtilebasiconly
	endif

	clr.l D2
	and.b #%11110000,d0	;%nnnn----
	move.b d0,D2
	
	clr.l d0
	move.b (a2),d0		;%NNNNNNNN
	subq.l #1,a2
	
	asl.l #8,d0
	or.w d0,D2			;NNNNNNNN nnnn----
	
	lsr.w #4,D2			;----NNNN NNNNnnnn
	add.l a1,D2			;Add Tile Base
	
	move.b (a2),d0
	addq.l #2,a2

	
	btst #2,d0
	bne drawtileyflip

drawtilexflip:
	move.w d2,$3C0002		;Write new Tilenum to address
	move.w #$0101,$3C0002	;PPPPPPPP NNNNAAVH Palette Tile,
							;				   Autoanim Flip
	jmp tiledone
	

drawtilexyflip:
	move.w d2,$3C0002		;Write new Tilenum to address
	move.w #$0103,$3C0002	;PPPPPPPP NNNNAAVH Palette Tile,
							;				   Autoanim Flip
	jmp tiledone

	
drawtileyflip:
	btst #3,d0
	bne drawtilexyflip
	
	move.w d2,$3C0002		;Write new Tilenum to address
	move.w #$0102,$3C0002	;PPPPPPPP NNNNAAVH Palette Tile,
							;				   Autoanim Flip
	jmp tiledone

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

drawtilecustom:
	move.b (a2),d0			;NNcc----
	and.b #%11111110,d0
	move.b d0,(a2)

	lsl.l #2,d0
	and.l #%0000001100000000,d0	;NN --------
	move.l d0,D2

	move.b (a2),d0
	and.b #%11111110,d0
	move.b d0,(a2)
	and.b #%00110000,d0		;cmd bits
	beq drawtilefill

	cmp.b #%00110000,d0
	beq drawtileempty

	
drawtiledouble:
	addq.l #1,a2
	move.b (a2)+,D2			;------NN nnnnnnnn - tile number
		
	add.l a1,D2				;Add Tile Base
	
	add.w #PatternDoubleHeight,d2
	
	move.w d2,$3C0002		;Write new Tilenum to address
	move.w #$0100,$3C0002	;PPPPPPPP NNNNAAVH Palette Tile, 
							;				   Autoanim Flip
	jmp tiledone

	
drawtilefill:
	addq.l #1,a2	
	move.b (a2)+,D2			;------bb nnnnnnnn - tile number
	
	add.l #patternFill,D2
	move.w d2,$3C0002		;tile data $PTTT - Palette / Tile
	move.w #$0100,$3C0002	;PPPPPPPP NNNNAAVH Palette Tile, 
							;				   Autoanim Flip
	jmp tiledone

	
	
drawtileempty:
	addq.l #1,a2
	move.b (a2)+,d0		;255=empty <255=tilenum
	cmp.b #255,d0
	bne drawtiletransp
	jmp tiledone
;;;;;;;;;;;;;;;;;;transparent

drawtiletransp:
	move.b d0,d2
	add.l a1,D2			;Add Tile Base
		
	move.w d2,$3C0002		;Write new Tilenum to address
	move.w #$0100,$3C0002	;PPPPPPPP NNNNAAVH Palette Tile, 
							;				   Autoanim Flip
	jmp tiledone
	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

DefineHspriteTilemap:
;Clear all hsprites to a blank tile (fixes scaling glitches)
	move.w #$0001,$3C0004		;Autoinc
	
	move.w #$0000,$3C0000
	move.l #$5F00/2,d0			;Two WORDS per loop
ClearSpritesAgain:	
	move.w #PatternFill,$3C0002		;Tile
	move.w #$0100,$3C0002			;Palette
	dbra d0,ClearSpritesAgain
	
	move.w #$0000,$3C0004		;Autoinc off

	
;;;;;;;;;;;; Define TileMap ;;;;;;;;;;;;;;;;;;;;;;;;
	move.w #$0000,d6		;Tile Vran Addr $0000
	
	;move.w #$0FFF,d5 		;Scale (16x16 Normal)
	move.w #$077F,d5 		;Scale (8x8   Half Size)
	;move.w #$0110,d5 		;Scale (Tiny!)
	
	move.l #32-1,d4			;Counter: Sprites (Width)
	move.l #24-1,d2			;Counter: Tiles per sprite (height)
	
	
;;;;;;;;;;;; Anchor Sprite (one) ;;;;;;;;;;;;;;;;;;;;;;;;
;First sprite is anchor to others!

	move.w #$8000,d7		;Attribs addr $8000+ (Shrink)
	Move.w d7,$3C0000 		
	move.w d5,$3C0002		;----HHHH VVVVVVVV - Shrink
	
	add.w #$200,d7			;$8200+ (Ypos)
	Move.w d7,$3C0000 		
	move.w #$F021,d0		;33=32 tall (looping) (13-31 are invalid)
	move.w d0,$3C0002		;YYYYYYYY YCSSSSSS Ypos 
	
	add.w #$200,d7			;$8400+ (Xpos)
	move.w d7,$3C0000 	
	move.w #$1000,$3C0002	;XXXXXXXX X------- Xpos
	
	sub.w #$400,d7			;$8000+ (Shrink)
	
		
;;;;;;;;;;;; Tiles (Columns) ;;;;;;;;;;;;;;;;;;;;;;;;
SpriteLoop:	
	move.l d2,d3			;Init Counter for Tilecount
	
TileLoop: ; Sprites in column ;;;;;;;;;;;
	move.w d6,$3C0000 		;$0000+ (TileAddr)
	move.w #$2200,$3C0002	;NNNNNNNN NNNNNNNN Tile Number 
	
	addq.w #1,d6			;$0001+ (TilePal)
	move.w d6,$3C0000 		
	move.w #$0100,$3C0002	;PPPPPPPP NNNNAAVH Palette Tile, 
								;Autoanim Flip
	addq.w #1,d6
	dbra d3,TileLoop		;Repeat for next Tile in column
	
	
;;;;;;;;;;;; end of column - Chained Sprite ;;;;;;;;;;;; 
	and.w #%1111111111000000,d6	;Next Tile Set
	add.w #%0000000001000000,d6
	add.w #$001,d7				;Next Sprite
	
	Move.w d7,$3C0000 		;Attribs addr $8000+ (Shrink)
	move.w d5,$3C0002		;----HHHH VVVVVVVV - Shrink
	
	add.w #$200,d7			;$8200+ (Ypos)
	Move.w d7,$3C0000 		
	move.w #$0040,$3C0002	;YYYYYYYY YCSSSSSS Ypos 
	
	add.w #$200,d7			;$8400+ (Xpos)
	move.w d7,$3C0000 	
	move.w #$0000,$3C0002	;XXXXXXXX X------- Xpos
	
	sub.w #$400,d7			;$8000+ (Shrink)
	
	dbra d4,SpriteLoop		;Next Column
	
	move.w #1,$3C0004 		;Set AutoInc
	rts
	
;;;;;;;;;;;; Spriteloop done ;;;;;;;;;;;; 
	
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

GetScreenPos: 				;Get Hpsrite Addr
	move.l d1,d0
	and.l #%11111100,d0
	rol.w #4,d0				;Xpos * 64 (32 sprites per colunn)
	move.l d0,a3
	
	move.l d4,d0
	and.l #%11111100,d0
	ror.w #1,d0				;Ypos * 2 (2 bytes per sprite)
	add.w d0,a3				;Address of 'TileAddr' (tilenum)
	rts	
	
	
	