;A0 A1 A2 A3
;D0 D1 D2

;A4=IX
;A2=Tilemap A1=TileOffset A3=Vram dest
			
drawtile:
	btst #0,d0
	ifnd tiletest_basiconly		;for minimal testing
		bne drawtileadvanced
	endif
	
	asl.b #1,d0				;%NNNNXYP0 ... Update flag cleared (bit 0)
	move.b d0,(a2)+
	
	
drawtilebasiconly:
	and.b #%11110000,d0		;%nnnn----

	clr.l D2
	move.b d0,D2
	clr.l d0
	move.b (a2)+,d0			;%NNNNNNNN
		
	asl.l #8,d0
	or.w d0,D2				;NNNNNNNN nnnn----
	
	lsl.l #1,d2				;32 bytes per tile
	add.l a1,D2				;Add Tile Base	
	move.l d2,a0

	move.l (a0)+,d0		;Get a source long from pattern
	move.l d0,(a3)		;Write to screen (8 pixels)	
			
	move.l (a0)+,d0		;Get a source long from pattern
	move.l d0,(128*1,a3)	;Write to screen (8 pixels)	
	
	move.l (a0)+,d0		;Get a source long from pattern
	move.l d0,(128*2,a3)	;Write to screen (8 pixels)	
	
	move.l (a0)+,d0		;Get a source long from pattern
	move.l d0,(128*3,a3)	;Write to screen (8 pixels)	
			
	move.l (a0)+,d0		;Get a source long from pattern
	move.l d0,(128*4,a3)	;Write to screen (8 pixels)	
	
	move.l (a0)+,d0		;Get a source long from pattern
	move.l d0,(128*5,a3)	;Write to screen (8 pixels)	
	
	move.l (a0)+,d0		;Get a source long from pattern
	move.l d0,(128*6,a3)	;Write to screen (8 pixels)	
	
	move.l (a0)+,d0		;Get a source long from pattern
	move.l d0,(128*7,a3)	;Write to screen (8 pixels)	

	jmp tiledone


drawtileadvanced:
	and.b #%00000110,d0		;%-NNNNXYP
	beq drawtilecustom		;X,Y flip 0 = special prog
	
	move.b (a2),d0
	and.b #%11111110,d0
	move.b d0,(a2)+
	
	ifd tiletest_noflip	;for minimal testing
		bra drawtilebasiconly
	endif

	clr.l D2
	and.b #%11110000,d0		;%nnnn---
	move.b d0,D2
	
	clr.l d0
	move.b (a2),d0
	subq.l #1,a2
	
	asl.l #8,d0
	or.w d0,D2				;%NNNNNNNN nnnn----
	
	asl.l #1,d2				;*32
	add.l a1,D2				;Add Tile Base
	move.l d2,a0
		
	move.l a3,d2			;Backup VRAM dest
		
		move.b (a2),d0
		addq.l #2,a2
		
		btst #2,d0
		bne drawtileyflip

drawtilexflip:
		move.l a1,-(sp)
		move.l #128,d3			;Line Vram width
		
		move.l #FlipLUT,a1	;Xflip lookup table
	
		move.w #7,d1		;Line Count -1
		clr.l d0
DrawTileNextLineRev:	
		move.b (a0)+,d0		;Load a byte
		move.b (a1,d0),d0	;Flip it
		move.b d0,(2,a3)	;Write to screen
		
		move.b (a0)+,d0		;Load a byte
		move.b (a1,d0),d0	;Flip it
		move.b d0,(3,a3)	;Write to screen
		
		move.b (a0)+,d0		;Load a byte
		move.b (a1,d0),d0	;Flip it
		move.b d0,(0,a3)	;Write to screen
		
		move.b (a0)+,d0		;Load a byte
		move.b (a1,d0),d0	;Flip it
		move.b d0,(1,a3)	;Write to screen
		
		add.l d3,a3		;Down a line
		dbra d1,DrawTileNextLineRev		;Next line
	move.l (sp)+,a1
	move.l d2,a3			;Restore VRAM dest
	jmp tiledone

	
drawtilexyflip:
	move.l a1,-(sp)
		move.l #FlipLUT,a1	;Xflip LUT
		move.l #128,d3			;Line Vram width

		add.l #32,a0		;Move to last byte
		move.w #7,d1		;Line Count -1
		clr.l d0
				
DrawTileNextLineRevY:	
		move.b -(a0),d0		;Get a source byte
		move.b (a1,d0),d0	;Xflip it
		move.b d0,(1,a3)	;Write it to screen
		
		move.b -(a0),d0		;Get a source byte
		move.b (a1,d0),d0	;Xflip it
		move.b d0,(0,a3)	;Write it to screen
		
		move.b -(a0),d0		;Get a source byte
		move.b (a1,d0),d0	;Xflip it
		move.b d0,(3,a3)	;Write it to screen
		
		move.b -(a0),d0		;Get a source byte
		move.b (a1,d0),d0	;Xflip it
		move.b d0,(2,a3)	;Write it to screen
		
		add.l d3,a3
		dbra d1,DrawTileNextLineRevY ;Next line
	move.l (sp)+,a1
	move.l d2,a3			;Restore VRAM dest
	jmp tiledone

	
drawtileyflip:
		btst #3,d0
		bne drawtilexyflip
		
		add.l #32,a0		;Move to last line
		move.w #7,d1		;Line Count -1
		clr.l d0
DrawTileNextLineY:			;A3=Vram Dest
			
		move.l -(a0),d0		;Get a source long from pattern
		move.l d0,(a3)		;Write to screen (8 pixels)	
				
		move.l -(a0),d0		;Get a source long from pattern
		move.l d0,(128*1,a3) ;Write to screen (8 pixels)	
				
		move.l -(a0),d0		;Get a source long from pattern
		move.l d0,(128*2,a3) ;Write to screen (8 pixels)	
		
		move.l -(a0),d0		;Get a source long from pattern
		move.l d0,(128*3,a3) ;Write to screen (8 pixels)	
		
		move.l -(a0),d0		;Get a source long from pattern
		move.l d0,(128*4,a3) ;Write to screen (8 pixels)	
		
		move.l -(a0),d0		;Get a source long from pattern
		move.l d0,(128*5,a3) ;Write to screen (8 pixels)	
		
		move.l -(a0),d0		;Get a source long from pattern
		move.l d0,(128*6,a3) ;Write to screen (8 pixels)	
		
		move.l -(a0),d0		;Get a source long from pattern
		move.l d0,(128*7,a3) ;Write to screen (8 pixels)	
	
	jmp tiledone

	
	
drawtileempty:
	addq.l #1,a2
	move.b (a2)+,d0	;255=empty <255=tilenum
	
	cmp.b #255,d0
	bne drawtiletransp
	jmp tiledone

	
drawtiletransp:		;;;;;;;;;;;;;;;;;;transparent
	move.b d0,d2
	lsl.l #5,d2				;32 bytes per tile
	add.l a1,D2				;Add Tile Base
	move.l d2,a0
	
	move.l a3,d2			;Backup VRAM dest
	
		move.w #7,d1		;Line Count -1
		clr.l d0
	
		move.l #128-2,d3	;Value to skip a line
		
DrawTileNextLineT:			;A3=Vram Dest
	
		move.w (a0)+,d0		;Get a source word from pattern
		beq DrawTileNextLineT1	;Skip if zero
		move.w d0,(a3)		;Write to screen (8 pixels)	
DrawTileNextLineT1:		

		addq.l #2,a3
		
		move.w (a0)+,d0		;Get a source word from pattern
		beq DrawTileNextLineT2	;Skip if zero
		move.w d0,(a3)		;Write to screen (8 pixels)	
DrawTileNextLineT2:

		add.l d3,a3			;Down a line
	
		dbra d1,DrawTileNextLineT	;Next line
		
	move.l d2,a3			;Restore VRAM dest
	jmp tiledone

	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

drawtilecustom:
	move.b (a2),d0			;NN------
	and.b #%11111110,d0
	move.b d0,(a2)

	lsl.l #2,d0
	and.l #%0000001100000000,d0
	move.l d0,D2

	move.b (a2),d0
	and.b #%11111110,d0
	move.b d0,(a2)
	and.b #%00110000,d0	;cmd bits
	bne notdrawtilefill
		jmp drawtilefill
notdrawtilefill:

	cmp.b #%00110000,d0
	beq drawtileempty
	

drawtiledouble:
	addq.l #1,a2
	move.b (a2)+,D2			;------NN nnnnnnnn - tile number
		
	asl.l #4,d2				;*16 bytes per  half tile
	add.l a1,D2				;Add Tile Base
	move.l d2,a0
				
DrawTileNextLineD:			;A3=Vram Dest

	move.l (a0)+,d0			;Get a source long from pattern
	move.l d0,(a3)			;Write to screen (8 pixels)	
	
	move.l d0,(128*1,a3) 	;Write to screen (8 pixels)
		
	move.l (a0)+,d0			;Get a source long from pattern
	move.l d0,(128*2,a3) 	;Write to screen (8 pixels)	
	move.l d0,(128*3,a3) 	;Write to screen (8 pixels)	
	
	move.l (a0)+,d0			;Get a source long from pattern
	move.l d0,(128*4,a3) 	;Write to screen (8 pixels)	
	move.l d0,(128*5,a3) 	;Write to screen (8 pixels)	
	
	move.l (a0)+,d0			;Get a source long from pattern
	move.l d0,(128*6,a3) 	;Write to screen (8 pixels)	
	move.l d0,(128*7,a3) 	;Write to screen (8 pixels)	
	
	jmp tiledone

	
drawtilefill:
	addq.l #1,a2
	move.b (a2)+,D2			;------MM nnnnnnnn - tile number
	
	asl.b #2,d2				;2 words per fill
	add.l #patternFill,D2
	move.l d2,a0

	move.l (a0),d0		;Line 1
	move.w (a0)+,d0		
	
	move.l (a0),d1		;Line 2
	move.w (a0),d1
	
	move.l d0,(a3)		;Fill 1	
	move.l d0,(128*2,a3) ;Write to screen (8 pixels)
	move.l d0,(128*4,a3) ;Write to screen (8 pixels)
	move.l d0,(128*6,a3) ;Write to screen (8 pixels)
	
	move.l d1,(128*1,a3) ;Write to screen (8 pixels)
	move.l d1,(128*3,a3) ;Write to screen (8 pixels)
	move.l d1,(128*5,a3) ;Write to screen (8 pixels)
	move.l d1,(128*7,a3) ;Write to screen (8 pixels)
		
	jmp tiledone
	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	

GetScreenPos: ; d1=x d4=y (in pairs of pixels)
	and.l #$FE,d1			;Effectively multiply block by 2
	and.l #$FF,d4
	
;	rol.l #1,d1				;Multiply X*2 (2 bytes per 4/8 pixels)
	rol.l #8,d4				;Multiply Y*128*2
	
	move.l #$00020000+(128*32),a3	;Screen starts at $20000
	add.l d4,a3
	add.l d1,a3
	rts
	
	
	
	
	